/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * COPSE Client Application
 * Classe:  COPSEClient
\******************************************************************************/


import java.awt.*;
import java.awt.event.*;


public class    COPSEClientMainWindow
    extends     Frame
    implements  WindowListener, ActionListener
{

	//{{DECLARE_CONTROLS
	java.awt.Panel panMessage;
	java.awt.Label lblMessage;
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar    menuBar;

	java.awt.Menu       mnProject;
	java.awt.MenuItem   mnProjectAbout;
	java.awt.MenuItem   mnProjectExit;

	java.awt.Menu       mnProcess;
	java.awt.MenuItem   mnProcessMeta;
	java.awt.MenuItem   mnProcessWork;

	java.awt.Menu       mnProduct;
	java.awt.MenuItem   mnProductStructure;
	java.awt.MenuItem   mnProductBaseline;

	java.awt.Menu       mnPeople;
	java.awt.MenuItem   mnPeopleUsers;
	java.awt.MenuItem   mnPeopleTeams;
	//}}


	public COPSEClientMainWindow() {

		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		addNotify();

		Insets insets = getInsets();

		setSize(insets.left + insets.right + 509,insets.top + insets.bottom + 114);

		add( "Center", new Panel() );

		panMessage = new java.awt.Panel();
		panMessage.setLayout(new BorderLayout(5,5));
		panMessage.setBounds(insets.left + 7,insets.top + 68,497,38);
		add("South", panMessage);
		lblMessage = new java.awt.Label("COPSE - User Session Manager");
		lblMessage.setBounds(14,15,469,15);
		panMessage.add("Center", lblMessage);

		addWindowListener( this );

		setTitle("COPSE - User Session Manager");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		menuBar = new java.awt.MenuBar();

		mnProject = new java.awt.Menu("Project");
		mnProjectAbout = new java.awt.MenuItem("About...");
		mnProject.add(mnProjectAbout);
		mnProject.addSeparator();
		mnProjectExit = new java.awt.MenuItem("Exit");
		mnProject.add(mnProjectExit);
		menuBar.add(mnProject);

		mnProcess = new java.awt.Menu("Process");
		mnProcessMeta = new java.awt.MenuItem("MetaProcesses...");
		mnProcess.add(mnProcessMeta);
		mnProcessWork = new java.awt.MenuItem("WorkProcess...");
		mnProcess.add(mnProcessWork);
		menuBar.add(mnProcess);

		mnProduct = new java.awt.Menu("Product");
		mnProductStructure = new java.awt.MenuItem("Structure...");
		mnProduct.add(mnProductStructure);
		mnProductBaseline = new java.awt.MenuItem("Baseline...");
		mnProduct.add(mnProductBaseline);
		menuBar.add(mnProduct);

		mnPeople = new java.awt.Menu("People");
		mnPeopleUsers = new java.awt.MenuItem("Users...");
		mnPeopleUsers.addActionListener( this );
		mnPeople.add(mnPeopleUsers);
		mnPeopleTeams = new java.awt.MenuItem("Teams...");
		mnPeople.add(mnPeopleTeams);
		mnPeople.addSeparator();
		menuBar.add(mnPeople);

		setMenuBar(menuBar);
		//}}
	}



    public synchronized void setVisible( boolean visible )
    {
        //if( visible )
        //    setLocation(50, 50);
    	super.setVisible( visible );
    }


    public void windowOpened(WindowEvent e)        {}
    public void windowClosing(WindowEvent e)       { System.exit(0); }
    public void windowClosed(WindowEvent e)        {}
    public void windowIconified(WindowEvent e)     {}
    public void windowDeiconified(WindowEvent e)   {}
    public void windowActivated(WindowEvent e)     {}
    public void windowDeactivated(WindowEvent e)   {}

    public void actionPerformed(ActionEvent e)
    {
	Frame f = new Frame();
	f.setLayout( new BorderLayout(0,0) );
	f.add( "Center", new Panel() );
	f.setTitle( "Child Frame" );
	f.setVisible( true );
    }

    public static void main (String [] args)
    {
        COPSEClientMainWindow win = new COPSEClientMainWindow();
	win.setVisible( true );
    }
}
