/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * COPSE Client Application
 * Classe:  COPSEGUIManager
\******************************************************************************/


import java.io.*;
import java.awt.*;
import java.awt.event.*;

import COPSE.*;

public class    COPSEGUIManager
    implements  WindowListener, ActionListener
{

    //* COPSE Client
    protected   COPSEClient     pCOPSEClient;


    //* COPSE GUI Managers
    protected   COPSEGUIProjectManager      pGUIProjectManager;
    //protected   COPSEGUIToolManager         pGUIToolManager;


    //* GUI Components
	protected   Frame           pMainWindow;
	protected   Label           mStatusLabel;

	// Menu
	protected   MenuBar         mMenuBar;


    public static void main( String[] args )
    {
        new COPSEGUIManager();
    }


	public COPSEGUIManager()
	{
	    //* Create GUI Managers
	    pGUIProjectManager = new COPSEGUIProjectManager( this );
	    //pGUIToolManager = new COPSEGUIToolManager( this );


        //* Main Window
		pMainWindow = new Frame();
		pMainWindow.setLayout(new BorderLayout(0,0));
		pMainWindow.addNotify();
		pMainWindow.addWindowListener( pGUIProjectManager );

		pMainWindow.setTitle( "COPSE - User Session Manager" );

		Insets insets = pMainWindow.getInsets();
		pMainWindow.setSize(insets.left + insets.right + 509,insets.top + insets.bottom + 114);

        // For while, an empty panel is inserted...
		pMainWindow.add( "Center", new Panel() );


        //* StatusLine...
        Panel panStatus;
		panStatus = new Panel();
		panStatus.setLayout(new BorderLayout(5,5));
		panStatus.setBounds(insets.left + 7,insets.top + 68,497,38);
		pMainWindow.add("South", panStatus);
		mStatusLabel = new Label("COPSE - User Session Manager");
		mStatusLabel.setBounds(14,15,469,15);
		panStatus.add("Center", mStatusLabel);



		//* Create Menus...
		mMenuBar = new MenuBar();

        pGUIProjectManager.AddMenu( mMenuBar );
        //pGUIToolManager.AddMenu( mMenuBar );

        /*
		mnProject           = new Menu("Project");
		mnProjectAbout      = new MenuItem("About...");
		mnProjectExit       = new MenuItem("Exit");
		mnProject.add(mnProjectAbout);
		mnProject.addSeparator();
		mnProject.add(mnProjectExit);
		menuBar.add(mnProject);

		mnProcess           = new Menu("Process");
		mnProcessMeta       = new MenuItem("MetaProcesses...");
		mnProcessWork       = new MenuItem("WorkProcess...");
		mnProcess.add(mnProcessMeta);
		mnProcess.add(mnProcessWork);
		menuBar.add(mnProcess);

		mnProduct           = new Menu("Product");
		mnProductStructure  = new MenuItem("Structure...");
		mnProductBaseline   = new MenuItem("Baseline...");
		mnProduct.add(mnProductStructure);
		mnProduct.add(mnProductBaseline);
		menuBar.add(mnProduct);

		mnPeople            = new Menu("People");
		mnPeopleUsers       = new MenuItem("Users...");
		mnPeopleTeams       = new MenuItem("Teams...");
		mnPeopleUsers.addActionListener( this );
		mnPeople.add(mnPeopleUsers);
		mnPeople.add(mnPeopleTeams);
		mnPeople.addSeparator();
		menuBar.add(mnPeople);
        */

		pMainWindow.setMenuBar(mMenuBar);


        //* Show Main Window
		pMainWindow.setResizable(false);
		pMainWindow.setVisible( true );


		//* Open Login Dialog
		COPSEDlgLogin dlg = new COPSEDlgLogin( pMainWindow, this );
		dlg.show();
	}




    public Frame    GetMainWindow()     { return pMainWindow; }


    // called by ToolManager after creating the Client
    public void SetClient( COPSEClient client )
    {
        pCOPSEClient = client;

        pGUIProjectManager.SetClient( client );
        //pGUIToolManager.SetClient( client );
        //pCollabManager.SetClient( client );
    }


    //* Send Events to Server
    public void     Send( CEvent event )
        throws IOException
    {
        if( pCOPSEClient != null )
            pCOPSEClient.GetConnector().Send( event );
    }


    //* Exit
    public void Exit()
    {
        if( pCOPSEClient == null )
        {
            // ???
            System.exit(0);
        }

        // Stops GUIProjectManager...
        //pGUIProjectManager.Exit();
    }


    public void OpenClient( String host, String port, String login, String password )
    {
        //System.out.println( "DEBUG: OpenClient("+host+","+port+","+login+","+password+")" );
        /* */
        try{
            //System.out.println( "DEBUG: Creating Client" );
            pCOPSEClient = new COPSEClient( host, Integer.parseInt(port), login, password );
            pCOPSEClient.start();

            pGUIProjectManager.SetClient( pCOPSEClient );
        }
        catch (Exception e)
        {
            e.printStackTrace( System.out );
            Exit();
        }
        /* */
    }


/*
    public synchronized void setVisible( boolean visible )
    {
        //if( visible )
        //    setLocation(50, 50);
    	super.setVisible( visible );
    }
*/
/* */
    public void windowOpened(WindowEvent e)        {}
    public void windowClosing(WindowEvent e)       { pGUIProjectManager._Close(false); }
    public void windowClosed(WindowEvent e)        {}
    public void windowIconified(WindowEvent e)     {}
    public void windowDeiconified(WindowEvent e)   {}
    public void windowActivated(WindowEvent e)     {}
    public void windowDeactivated(WindowEvent e)   {}

    public void actionPerformed(ActionEvent e)
    {
/*    	Frame f = new Frame();
    	f.setLayout( new BorderLayout(0,0) );
    	f.add( "Center", new Panel() );
    	f.setTitle( "Child Frame" );
    	f.setVisible( true );
*/
    }
/* */
}
