/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: AGENT
 * Classe:  CTeam
\******************************************************************************/

package AGENT;


import java.io.*;
import java.util.*;


public class    CTeam
    extends     CAgent
{
    protected CMember   pManager;
    protected Vector    pMembers;

    public CTeam()
    {
        super();
        pManager = null;
        pMembers = new Vector();
    }

    public void     SetManager  (CMember mgr)   { pManager = mgr; }
    public CMember  GetManager  ()              { return pManager; }


    public void     AddMember   (CMember mgr)   { pMembers.addElement(mgr); }
    public void     RemoveMember(CMember mgr)   { pMembers.removeElement(mgr); }

    public Enumeration  GetMembers()            { return pMembers.elements(); }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CTeam");
        if( pManager != null )
            pStr.println( "       Manager:     " + pManager.GetName() );
        else
            pStr.println( "       Manager:     null" );


        pStr.print(   "       Members(id): " );
        Enumeration en = pMembers.elements();
        while( en.hasMoreElements() )
        {
            CMember mbr = (CMember) en.nextElement();
            pStr.print( mbr.GetId() + "; " );
        }
        pStr.println();

        super.DEBUG_write( pStr );
    }

}
