/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE UI_STARTUP
 * PACOTE BW.INTERFACE
 * DATA DE CRIACAO 11 / 01 / 2001
 * DATA DE ALTERACAO 30 / 07 / 2001
 */

package BW.Interface;

import java.util.Vector;

import BW.typeIdDefault;
import BW.kernel.*;
import BW.control.*;
import BW.storage.*;


/**
 * classe UI_StartUp e responsavel pela inicializacao
 * da camada de interface, representada pelo pacote
 * Interface do framework BW.
 * @autor Manuele K P
 * @version 1.2
 */
public class UI_StartUp {
	
	//////////////////////////////// ATRIBUTOS /////////////////
	static UI_Interface cont;
	
	static FC_CL_Context clcont;
	

	//////////////////////////////// METODOS ///////////////////
	
	/** Faz a inicializacao do pacote Interface.
	 *  @param Vector facades	fachadas para o pacote control
	 *  @return UI_Interface	fachada e gerente para a camada de interface
	 *  @see BW.storage.FC_CL_Monitor
	 *  @see BW.storage.FC_CL_Context
	 */
	public static  UI_Interface Start (Vector facades) {
	
		//inicializa UI_Interface
		cont = new UI_Interface();
		
		//busca a fachada de contextualizacao
		clcont = null;
		try {
			clcont = (FC_CL_Context) facades.lastElement();			
		} catch (ClassCastException cce) {
			clcont = (FC_CL_Context) facades.firstElement();		
		}
		
		//seta as referencias necessarias
		cont.setFCCLContext (clcont);
		clcont.setUI (cont);
		
		return cont;
		
	}
	
		
	/** Faz a inicializacao do pacote Interface, utilisando o objeto
	 *  UI_Interface passado por parametro. Isso permite que subclasses
	 *  de UI_Interface sejam utilisadas no BW.
	 *  NOTA: acso seja passado um objeto NULL como UI_Interface, este
	 *  metodo instancia uma nova UI8INterface, como o default.
	 *  @param Vector facades	fachadas para o pacote control
	 *  @param UI_Interaface interfc	gerente de interface a ser utilizado
	 *  @return UI_Interface	fachada e gerente para a camada de interface
	 *  @see BW.storage.FC_CL_Monitor
	 *  @see BW.storage.FC_CL_Context
	 */
	public static UI_Interface Start (Vector facades, UI_Interface interfc) {

		//inicializa UI_Interface
		if (interfc != null)
			cont = (UI_Interface) interfc;
		else
			cont =  new UI_Interface();
		
		//busca a fachada de contextualizacao
		clcont = null;

		try {
			clcont = (FC_CL_Context) facades.lastElement();			
		} catch (ClassCastException cce) {
			clcont = (FC_CL_Context) facades.firstElement();		
		}
		
		//seta as referencias necessarias
		cont.setFCCLContext (clcont);
		clcont.setUI (cont);
		
		return cont;
	}


 	/** Retorna a fachada para as funcoes de contextualizacao,
 	 *  que para a camada de interface e o gerente UI_Interface
	 *  @param UI_Interface	fachada de contextualizacao
	 */
	public static UI_Interface getContextFacade () {
		//retorna fachada de contextualizacao
		return cont;
		//return null;
	
	}

}
