/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTOR LUIZ ANGELO BARCHET ESTEFANEL
 * CLASSE bar
 * PACOTE BW.UML.ClickBar
 * DATA DE CRIACAO 16 / 01 / 2001
 */


package BW.UML.ClickBar;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import BW.UML.ClickBar.*;
import BW.UML.*;
import BW.kernel.*;


/**
 * classe bar representa cada elemento(barra) do grafico de barras
 * @author Luiz Angelo Barchet Estefanel
 * @version 1.0
 */

public class bar implements ClickableBar
{
   private BW_Event prototype;
   private AwarenessMainWindow myFather;
   private String value = null;   
   private String label = null;
   private Color color = Color.blue;
   private String style = "SOLID";


	/** construtor 
	 * @param AwarenessMainWindow myFather	referencia `a janela principal da aplicacao
	 * @param BW_Event prototype	evento que esta barra representa
	 * @param String value valor da barra
	 * @param String label nome da barra
	 * @param String color cor da barra
	 * @param String style estilo da barra (solida ou transparente)
	 */

   public bar (AwarenessMainWindow myFather, BW_Event prototype, String value, String label, Color color, String style)
   {
      this.myFather = myFather;
      this.prototype = (BW_Event)prototype.clone();
      this.value = value;
      this.label = label;
      this.color = color;
      this.style = style;
   }


	/** retorna o valor desta barra
	 * @return	String valor da barra
	 */
   public String getValue() {
      return this.value;
   }

	/** retorna o nome desta barra
	 * @return	String nome da barra
	 */
   public String getLabel() {
      return this.label;
   }


	/** retorna a cor desta barra
	 * @return	String cor da barra
	 */
   public Color getColor() {
      return this.color;
   }

  	/** retorna o estilo desta barra
	 * @return	String estilo da barra
	 */
	public String getStyle() {
      return this.style;
   }
   
   public void clickAction () {
        myFather.showEvent(prototype);
   }
}