/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORES LUIZ ANGELO B. ESTEFANEL E MANUELE KIRSCH PINHEIRO
 * Classe ServerID
 * PACOTE BW.UML.ObjId
 * DATA DE CRIACAO 28 / 01 / 2001
 * DATA DE ALTERACAO 30 / 05 / 2001
 */
package BW.UML.ObjId;


/**
 * Classe ServerID e o servidor de identificadores
 * de objetos para uso do framework para awareness BW,
 * quando combinado ao groupware CUTE (construido com
 * o framework COPSE).
 * Alteracao incluida nos parametro de linha de comando
 * para permitir o uso com outros sistemas.
 * COPSE e CUTE sao de autoria de Marcio Dias, pela
 * COPPE/UFRJ, 1998.
 * @author Manuele Kirsch Pinheiro
 * @author Luiz Angelo B. Estefanel
 * @version 1.2
 */
 public class ServerID {

	static int port = 5433;
	static String host = "localhost";
	static String dbname = "bw";
	static String user = "BW";
	static String passwd = "";
	
	public static void main (String argv[]) {
		
		//Thread objServer = new ObjIdServer();
		//String host="localhost";

		if (argv.length>=1) {
                    // argumentos: -h host -d database -u user -s password -?
                    for (int i=0; i<argv.length;i++){
                    	String arg = argv[i];
                    	System.out.println ("Analizing "+arg);
                    	if (arg.charAt(0)=='-') {
                    		switch (arg.charAt(1)) {
                    			case 'h':
                    				host = new String (argv[i+1]);
                    		                break;	
                    		                
                    			case 'd':
                    				dbname = new String (argv[i+1]);
                    		                break;	
                    		                
                    		  case 'u':
                    				user = new String (argv[i+1]);
                    		                break;	
                    		  
                    		  case 's':
                    		  	passwd = new String (argv[i+1]);
                    		  	        		  break;
                    		  	              
                    		  case '?':
                    			default:
                    				System.out.println ("Use: java BW.UML.UML_Setup [-h host] [-d database] [-u user] [-?] ");
                    				System.exit(0);
                    		}
                    	}
                    }
                }

		
		ObjIdServer objServer = new ObjIdServer(host,dbname,user,passwd);
		
		objServer.init(port);
		
	}
}