/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE FC_CL_MONITOR
 * PACOTE CONTROL
 * DATA DE CRIACAO 11 / 01 / 2001
 */

package BW.control;

import BW.kernel.*;
import BW.control.*;


//import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;



/**
 * A classe FC_CL_Monitor serve de fachada para as funcoes de monitoramento
 * da camada de controle (pacote control) do framework BW.
 * Atraves desta classe que se da a comunicacao entre o groupware, que
 * notifica o framework BW sobre a ocorrencia de eventos.
 * @author Manuele Kirsch Pinheiro
 * @version 1.0
 */
public class FC_CL_Monitor {

	////////////////////////////////////
	///// AINDA FALTA MUITA COISA //////
	////////////////////////////////////


      ////////////////////////// ATRIBUTOS ////////////////////////////

      /** gerente de monitoramente da camada de controle */
      CL_Monitor monitor;


      /////////////////////////// CONSTRUTOR //////////////////////////

      public FC_CL_Monitor () {
      		monitor = null;
      }

      /////////////////////////// METODOS ////////////////////////////


      /** seta o gerente de monitoramento da camada de controle.
       * @param	CL_Monitor mon	novo gerente de monitoramento
       */
      public void setCLMonitor (CL_Monitor mon) {
      		this.monitor = mon;
      }

      /** retorna o gerente de monitoramento da camada de controle.
       * @return	CL_Monitor 	gerente de monitoramento usado
       */
      public CL_Monitor getCLMonitor () {
      		return this.monitor;
      }



      /** Faz o registro de um novo tipo de evento no sistema
       * @param		BW_Event prot	prototipo do tipo de evento a ser resgistrado
       * @return	boolean		true se o evento foi registrado com sucesso.
       */
      public boolean eventRegister (BW_Event prot) {
      		boolean ret = false;
      		try {
      			ret = this.monitor.eventRegister (prot);
      		}catch (Exception e) {      		
      		}      		
      		return ret;
      }

	/** remove o registro de um determinado tipo de evento
	 * @param 	BW_Event evt	prototipo de evento do tipo desejado
	 * @return 	boolean 	true se removeu o tipo de evento,
	 *				false se nao foi possivel ou se o tipo evento
	 *				nao estava registrado.
	 */
	public boolean eventRemove (BW_Event evt) {
		boolean ret = false;
		try {
			ret = this.monitor.eventRemove (evt);
		}catch (Exception e) {
		}
		return ret;
	}
				

      /** Informa sobre a ocorrencia de um unico evento.
       * @param		BW_Event evt	evento ocorrido
       * @return	boolean		true se a ocorrencia foi registrada com sucesso
       */
      public boolean eventOccurence (BW_Event evt) {
      		boolean ret = false;
      		try {
      			ret = this.monitor.eventOccurrence(evt);
      		}catch (Exception e) {
      		}
 		return ret;     		
      }

      /** Informa sobre a ocorrencia de diversos eventos em uma unica chamada.
       * @param		Vector evts	Vetor de BW_Events ocorridos
       * @return	boolean		true se a ocorrencia foi registrada com sucesso
       */
      public boolean eventOccurence (Vector evts) {
      		boolean ret = false;
      		try {
      			ret = this.monitor.eventOccurence(evts);
      		}catch (Exception e) {
      		}
 		return ret;     		
      	
      }


      /** Ativa ou desativa o controle dos identificadores
       * dos objetos para os eventos dentro da camada de controle
       * @param	boolean active	true = ativa o controle interno
       *			false = desativa o controle interno
       */
      public void setControlIds (boolean active) {
      		try {
      			this.monitor.setChangeId(active);
      		} catch (Exception e) {
      		}		
      }

      /** Seta o proximo identificador de objeto disponivel para os eventos
       * @param	int lastId	proximo identificador de objeto a ser usado
       */
      public void setLastId (int last) {
		try {
			this.monitor.setLastId(last);
		} catch (Exception e) {
		}
      }


      	/** adiciona um novo membro ao grupo
         * @param 	BW_Member newmb	novo membro do grupo
	 * @return	boolean true se a insercao ocorreu sem problema
	 */
	public boolean addMember (BW_Member newmb) {
		boolean ret= false;	
		try {
			ret = this.monitor.addMember (newmb);
		}catch (Exception e) {
		}
		return ret;
	}
	
	
        /** remove um membro do grupo
         * @param 	BW_Member memb	membro do grupo a ser removido
	 */
	public void removeMember (BW_Member memb) {
		try {
			this.monitor.removeMember (memb);		
		}catch (Exception e) {
		}		
	}
	

      /** Seta um novo grupo para o CL_Monitor
       * @param BW_Group newgrp	novo grupo a ser trabalhado
       */
      public void setGroup (BW_Group grp) {
		try {
			this.monitor.setGroup(grp);
		}catch (Exception e) {
		}		
      }


      /** retorna o grupo ativo no momento
       * @return	BW_Group	grupo ativo
       */
      public BW_Group getGroup () {
      		BW_Group grp = null;
		try {
			grp = this.monitor.getGroup();
		}catch (Exception e) {
		}		
		return grp;
      }

      /** Retorna o registro com o conjunto completo de eventos registrados.
       * @return	BW_Register	registro completo
       */
      public BW_Register getRegister () {
      		BW_Register ret = null;
		try {
			ret = this.monitor.getRegister();
		}catch (Exception e) {
		}		      		
                return ret;
      }

      /** adiciona um novo papel ao grupo
       * @param 	BW_Paper newpp	novo papel para o grupo
       * @return	boolean true se a insercao ocorreu sem problema
       */
	public boolean addPaper (BW_Paper newpp) {	
		boolean ret = false;	
		try {
			this.monitor.addPaper (newpp);		
			ret = true;
		}catch (Exception e) {
			ret = false;
		}		
		return ret;
	}
	
        /** remove um papel do grupo. ATENCAO! Isso nao vai retira-lo dos usuarios!!
         * @param 	BW_Paper pap	papel do grupo a ser removido
	 */
	public void removePaper (BW_Paper pap) {
		try {
			this.monitor.removePaper (pap);
		}catch (Exception e) {
		}					
	}

	
	/** Solicita o envio imediado de todas informacoes para o meio de armazenamento */
	public void saveAll () {
		this.monitor.saveall();
	}
	
	/** Finaliza as operacoes */
	public void terminate () {
	       monitor.terminate () ;
	}
}