/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE ST_CONTROLER
 * PACOTE BW.STORAGE
 * DATA DE CRIACAO 21 / 07 / 2000
 */

package BW.storage;

import BW.kernel.*;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * classe ST_Controler e responsavel pelo controle do
 * armazenamento e resgate dos dados coletados
 * @autor Manuele K P
 * @version 1.0
 */
public class ST_Controler {

	///////////////////////////////////////
	////// FALTA MUITA COISA AINDA  //////
	//////////////////////////////////////

	////////////////////////// ARGUMENTOS ////////////
	
        /** comunicacao com a camada de controle */
	//FC_ST_Context facade;

	/** estrategista responsavel pelo acesso fisico
	 * @see BW.storage.ST_Strategist
	 */
	ST_Strategist strategy;
	
	/** setup com informacoes basicas sobre o sistema */
	ST_Setup setup;
	
	
	////////////////////////// CONSTRUTOR /////////////
        public ST_Controler () {
        	strategy = null;
        	setup = null;
        }
	

        	
	///////////////////////// METODOS /////////////////
	
	
	/////////////////// SAVES
	
	/** executa um statement SQL junto a base de dados
	 * @param 	String sql	String com o statement SQL
	 * @return	boolean		true se o statement foi executado com sucesso,
	 *				false, caso contrario.
	 */
	public boolean save (String sql) {
		boolean ret = false;
		try {
			ret = this.strategy.save (sql);
		}catch (Exception e) {
		
		}
		return ret;
	}

		
	/** demanda o armazenamento do registro de eventos junto a base de dados
	 * @param 	BW_Register what	BW_Register a ser armazenado
	 * @return	boolean			true se as informacoes foram armazenadas,
	 *					false se nao o foram.
	 */
	public boolean save (BW_Register what) {
		boolean ret = false;
		try {
			ret = this.strategy.save ((BW_Element)what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um grupo junto a base de dados
	 * @param 	BW_Group what	BW_Group a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Group what) {
		boolean ret = false;
		try {
			ret = this.strategy.save ((BW_Element)what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um papel isolado junto a base de dados
	 * @param 	BW_Paper what	BW_Paper a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Paper what) {
		boolean ret = false;
		try {
			ret = this.strategy.save ((BW_Element)what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um membro isolado junto a base de dados
	 * @param 	BW_Member what	BW_Member a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Member what) {
		boolean ret = false;
		try {
			ret = this.strategy.save ((BW_Element)what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um unico evento isolado junto a base de dados
	 * @param 	BW_Event what	BW_Event a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Event what) {
		boolean ret = false;
		try {
			ret = this.strategy.save ((BW_Element)what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um elemento generico isolado junto a base de dados
	 * @param 	BW_Element what	BW_Element a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (BW_Element what) {
		boolean ret = false;
		try {
			ret = this.strategy.save (what);
		}catch (Exception e) {
		
		}
		return ret;
	}
	
		
	/** demanda o armazenamento de um conjunto de elementos junto a base de dados.
	 * Este conjunto deve conter somente objetos de subclasses BW_Element ou da propria,
	 * mas estes objetos podem ser de diferentes classes.
	 * @param 	Vector what	conjunto de informacoes a ser armazenado
	 * @return	boolean		true se as informacoes foram armazenadas,
	 *				false se nao o foram.
	 */
	public boolean save (Vector what) {
		boolean ret = true;
		Hashtable toSave = new Hashtable();
		
		//separa os elementos em vetores dedicadas a cada tipo		
		for (int i=0; i<what.size();i++) {			
			try {
			   BW_Element el = (BW_Element) what.elementAt(i);
			   Vector vtype = (Vector) toSave.get (el.getClass().getName());
			   if (vtype == null) {
			   	vtype = new Vector();
			   	vtype.addElement (el);
			   	toSave.put (el.getClass().getName(),vtype);
			   }
                           else {
                                vtype.addElement (el);
                           }
			}catch (Exception e) {
		            ret = false;
			}
		}
		
		//manda salvar cada um em separado
		Enumeration enum = toSave.elements();
		while ( enum.hasMoreElements () ) {		
			Vector vtype = (Vector) enum.nextElement();
			boolean	r = this.strategy.save (vtype);			
			ret = ret && r;
		}
		
		return ret;
	}
	
	
	/** envia para o armazenamento um vetor exclusivamente composto por
	 *  instancias de BW_Event (ou de subclasses desta).
	 * @param	Vector what	vetor de eventos a serem salvos
	 * @return	boolean		true se a operacao ocorreu sem problemas
	 */
	public boolean saveEvents (Vector what)	{
		boolean ret = false;
		try {
			ret = this.strategy.save (what);
		} catch (Exception e) {
			ret = false;
		}
		
		return ret;
	}

		
	/** demanda o armazenamento das informacoes de setup do sistema
	 */
	public void saveSetup () {
		try {
			this.strategy.setSetup (this.setup);			
			this.strategy.saveSetup ();
		}catch (Exception e) {
		
		}
	}
	
	
	
	/////////////////// READS UNICOS
	
	/** executa uma QUERY SQL junto a base de dados
	 * @param 	String sql	query a ser executada
	 * @return	Vector 		resultados lidos da query (poder ser null)
	 */
	public Vector read (String sql) {
		Vector ret = null;
		try {
			ret = this.strategy.read (sql);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma instancia de BW_Register
	 * @param	BW_Register what	instancia a ser atualizada
	 * @return	BW_Register		instancia lida da base de dados
	 */
	public BW_Register read (BW_Register what) {
		BW_Register ret = null;
		try {
			ret = (BW_Register) this.strategy.read ((BW_Element) what, what.getObjId());
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma instancia de BW_Group
	 * @param	BW_Group what	instancia a ser atualizada
	 * @return	BW_Group	instancia lida da base de dados
	 */
	public BW_Group read (BW_Group what) {
		BW_Group ret = null;
		try {
			ret = (BW_Group) this.strategy.read ((BW_Element) what, what.getObjId());
			//System.out.println ("[DEBUG]ST_Controler.read(BW_Group): "+ret);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	                               	
	/** faz a carga atualizada de uma unica instancia de BW_Paper
	 * @param	BW_Paper what	instancia a ser atualizada
	 * @return	BW_Paper	instancia lida da base de dados
	 */
	public BW_Paper read (BW_Paper what) {
		BW_Paper ret = null;
		try {
			ret = (BW_Paper) this.strategy.read ((BW_Element) what, what.getObjId());
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
	/** faz a carga atualizada de uma unica instancia de BW_Member
	 * @param	BW_Member what	instancia a ser atualizada
	 * @return	BW_Member	instancia lida da base de dados
	 */
	public BW_Member read (BW_Member what) {
		BW_Member ret = null;
		try {
			ret = (BW_Member) this.strategy.read  ((BW_Element) what, what.getObjId());
			//System.out.println ("[DEBUG]ST_Controler.read(BW_Member): member: "+ret);
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	

		
	/** faz a carga atualizada de uma unica instancia generica de BW_Element
	 * @param	BW_Element what	instancia a ser atualizada
	 * @return	BW_Element	instancia lida da base de dados
	 */
	public BW_Element read (BW_Element what) {
		BW_Element ret = null;
		try {
			ret = (BW_Element) this.strategy.read ( what, what.getObjId());
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
		
	/** faz a carga atualizada de um unico evento ocorrido
	 * @param	BW_Event what	instancia a ser atualizada
	 * @return	BW_Event	instancia lida da base de dados
	 */
	public BW_Event read (BW_Event what) {
		BW_Event ret = null;
		try {
			ret = (BW_Event) this.strategy.read  ((BW_Element) what, what.getObjId());
		} catch (Exception e) {
			ret = null;
		}
		return ret;
	}
	
	
        /** demanda a re-leitura das informacoes de setup do sistema */
        public void readSetup () {
        	try {
        		ST_Setup st = this.strategy.readSetup();
        		if (st!=null)
        			this.setup = st;
        	} catch (Exception e) {
        	
        	}
        }

	
	///////////////////  READS EM GRUPO
	
	/** Le todas as instancias armazenadas de registro,
	 * segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Register what	instancia modelo, com o typeid setado
	 * @return	Vector 			instancias lidas
	 **/
	public Vector readAll (BW_Register what) {
		Vector ret = null;
		try {
			ret = this.strategy.read ((BW_Element) what);
		} catch (Exception e) {
		
		}
		return ret;	
	}
	
	/** Le todas as instancias de grupo armazenadas,
	 * segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Group what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Group what) {
		Vector ret = null;
		try {
			System.out.println ("[DBG]ST_Controler.readAll(BW_Member): reading...");
			ret = this.strategy.read ((BW_Element) what);
		} catch (Exception e) {
		        System.out.println ("[DBG]ST_Controler.readAll(BW_Member): exception catch");
		        e.printStackTrace();		
		}
		return ret;	
	}
	
	/** Le todos papeis armazenados, segundo o identificador de
	 * tipo passado na instancia modelo
	 * @param	BW_Paper what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Paper what) {
		Vector ret = null;
		try {
			ret = this.strategy.read ((BW_Element) what);
		} catch (Exception e) {
		
		}
		return ret;	
	
	}
	
	/** Le todos os membros armazenadas, segundo o identificador
	 * de tipo passado na instancia modelo.
	 * @param	BW_Member what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Member what) {
		Vector ret = null;
		try {
			ret = this.strategy.read ((BW_Element) what);
		} catch (Exception e) {
		
		}
		return ret;		
	}

		
	/** Le, de forma generica, todas as instancias armazenadas
	 * de um determinado tipo, identificado pelo typeid da instancia modelo.
	 * @param	BW_Element what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Element what) {
		Vector ret = null;
		try {
			ret = this.strategy.read (what);
		} catch (Exception e) {
		
		}
		return ret;	
	
	}
	
	
	/** Le todas as instancias armazenadas de um determinado tipo
	 * de evento, segundo o identificador de tipo passado na instancia modelo
	 * @param	BW_Event what	instancia modelo, com o typeid setado
	 * @return	Vector 		instancias lidas
	 **/
	public Vector readAll (BW_Event what) {
		Vector ret = null;
		try {
			ret = this.strategy.read ((BW_Element) what);
		} catch (Exception e) {
		
		}
		return ret;		
	}
	

	
	//////////////////// READS POR TEMPO
	
	/** faz a leitura de todos os membros, de um determinado tipo, que
	 *  estiveram ativos pela ultima vez no sistema dentro do periodo
	 *  indicado pelo intervalo passado.
	 * @param	BW_Member what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Member what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.strategy.read ((BW_Element) what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }
	
	/** faz a leitura de todos os eventos, de um determinado tipo, que
	 *  ocorreram dentro do periodo indicado pelo intervalo passado.
	 * @param	BW_Event what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Event what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.strategy.read ((BW_Element) what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }

	/** faz a leitura de todos os profiles, de um determinado tipo, que
	 *  possuem o intervalo de interesse dentro do periodo
	 *  indicado pelo intervalo passado.
	 * @param	BW_Profile what		instancia modelo, com o identificador do tipo desejado
	 * @param 	BW_TimeInterval when	intervalo de interesse
	 * @return	Vector			vetor com as instancias recuperadas
	 */
        public Vector readByTime (BW_Profile what, BW_TimeInterval when) {
        	Vector ret = null;
        	try {
        		ret = this.strategy.read ((BW_Element) what, when);
        	}catch (Exception e) {
        	
        	}
        	return ret;
        }
        	


	///////////////////// READS EVENTOS
	
	/** Le todos os eventos que sao de interesse do profile passado.
	 * @param	BW_Profile what		profile descrevendo os tipos de eventos
	 *					e o intervalo de interesse.
	 * @return	Vector			todos os eventos lidos
	 */
	public Vector readEvents (BW_Profile what) {
		Vector ret = null;
		try {
			Vector evts = new Vector();
			Enumeration types = what.getEvents().keys();
			BW_TimeInterval interv = what.getInterval();
			
			while (types.hasMoreElements()) {
				//pega o nome da classe e o typeid
				String key = (String) types.nextElement();
				int cindex = key.indexOf ("-");
				String eclass = key.substring (0,cindex);
				int etype = Integer.parseInt (key.substring(cindex+1,key.length()));
				
				BW_Event model = (BW_Event) Class.forName(eclass).newInstance();
				model.setTypeId (etype);
				model.setObjId (BW.typeIdDefault.UNSET);
				
				//le os eventos desse tipo
				System.out.println ("[DBG]ST_CONTROLER.READEVENTS: reading type "+model.getTypeId());
				Vector v = this.strategy.read ((BW_Element) model, interv);
				if (v!=null)
				    for (int i=0; i<v.size();i++)
					evts.addElement (v.elementAt(i));
				
			}
		
			if (!evts.isEmpty())
				ret = evts;
		} catch (Exception e) {
		
		}
		return ret;
	
	}
	
	///////////////////// SET E GET
	
	/** seta o estrategista ativo no pacote storage
	 * @param ST_Strategist	estrategista
	 */
	public void setStrategist (ST_Strategist stg) {
		this.strategy = stg;
	}
	
	/** seta o objeto com inforacoes de setup do sistema.
	 * @param ST_Setup	setup com informacoes sobre o sistema
	 */
	public void setSetup (ST_Setup stp) {
		this.setup = stp;
	}
	
	/** retorna o estrategista atualmente em uso
	 * @retun ST_Strategist		estrategista atual
	 */
	public ST_Strategist getStrategist () {
		return this.strategy;
	}
	
	/** retora o objeto com informacoes sobre o setup do sistema
	 * @return ST_Setup	setup do sistema
	 */
	public ST_Setup getSetup () {
		return this.setup;
	}
	
	
	/////////////////////////////////////////////////////
	
	/** Finaliza as operacoes */
	public void terminate () {
		System.out.println ("[DBG]ST_Controle.terminate: finalizing activities");	
		//this.saveSetup();
	        strategy.terminate () ;
	}
	
}
