/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE ST_STARTUP
 * PACOTE BW.STORAGE
 * DATA DE CRIACAO 10/ 01 / 2001
 */

package BW.storage;

import BW.kernel.*;

import java.util.Vector;
//import java.util.Hashtable;


/**
 * classe ST_StartUp faz a inicializacao da camada de armazenamento,
 * definida no pacote storage do framework BW.
 * @autor Manuele K P
 * @version 1.0
 */
public class ST_StartUp {

	//////////////////////////////// ATRIBUTOS /////////////////
	
	/** Fachada para as funcoes de monitoramento */
	static FC_ST_Monitor mon;
	
	/** Fachada para as funcoes de contextualizacao */
	static FC_ST_Context cont;
	
	
	//////////////////////////////// METODOS ///////////////////
	
	/** Faz a inicializacao do pacote Storage
	 *  @param ST_Implementor implementor	implementor especifico para o groupware
	 */
	public static Vector Start (ST_Implementor implementor) {
		Vector v = null;
	
        	//seta o implementor
        	ST_Implementor impl = implementor;
		
		//inicializa o setup - le o setup da base de dados
		ST_Setup set = (ST_Setup) impl.read (new ST_Setup());
		
		if (set==null)
			set =  new ST_Setup();
		
		//inicializa o strategist
		ST_Strategist st = new ST_Strategist();		
		
		//inicializa o controller
		ST_Controler cl = new ST_Controler ();
		
		//inicializa as fachadas
		mon = new FC_ST_Monitor();
		cont = new FC_ST_Context();
		
		//setar as ligacoes entre as classes
		mon.setControler (cl);
		cont.setControler (cl);
		cont.setStrategist (st);
		
		cl.setStrategist (st);
		cl.setSetup (set);
		//cl.setFCMonitor (mon);  //?
		//cl.setFCContext (cont); //?
		
		st.setControler (cl);
		st.setImplementor (impl);
		st.setSetup (set);
		st.setFCContext (cont);
		
		
		//retornar as fachadas
		v = new Vector();
		v.addElement (mon);
		v.addElement (cont);
	
		return v;	
	}

	
	/** Faz a inicializacao do pacote Storage
	 *  @param ST_Implementor implementor	implementor especifico para o groupware
	 *  @param ST_Strategist strategy	strategist especifico para o groupware
	 */
	public static Vector Start (ST_Implementor implementor, ST_Strategist strategy) {
		Vector v = null;
	
		//seta o implementor
        	ST_Implementor impl = implementor;
		
		//inicializa o setup - le o setup da base de dados
		ST_Setup set = (ST_Setup) impl.read (new ST_Setup());
		
		//seta o strategist
		ST_Strategist st = strategy;		
		
		//inicializa o controller
		ST_Controler cl = new ST_Controler ();
		
		//inicializa as fachadas
		mon = new FC_ST_Monitor();
		cont = new FC_ST_Context();
		
		//setar as ligacoes entre as classes
		mon.setControler (cl);
		cont.setControler (cl);
		cont.setStrategist (st);
		
		cl.setStrategist (st);
		cl.setSetup (set);
		//cl.setFCMonitor (mon);  //?
		//cl.setFCContext (cont); //?
		
		st.setControler (cl);
		st.setImplementor (impl);
		st.setSetup (set);
		st.setFCContext (cont);
		
		
		//retornar as fachadas
		v = new Vector();
		v.addElement (mon);
		v.addElement (cont);
	    	
		return 	v;
	}
	
	
	/** Faz a inicializacao do pacote Storage
	 *  @param ST_Implementor implementor	implementor especifico para o groupware
	 *  @param ST_Strategist strategy	strategist especifico para o groupware
	 *  @param ST_Controler controller	controller especifico para o groupware
	 */
	public static Vector Start (ST_Implementor implementor, ST_Strategist strategy, ST_Controler controller) {
		Vector v = null;
	
		//seta o implementor
        	ST_Implementor impl = implementor;
		
		//inicializa o setup - le o setup da base de dados
		ST_Setup set = (ST_Setup) impl.read (new ST_Setup());
		
		//seta o strategist
		ST_Strategist st = strategy;		
		
		//inicializa o controller
		ST_Controler cl = controller;
		
		//inicializa as fachadas
		mon = new FC_ST_Monitor();
		cont = new FC_ST_Context();
		
		//setar as ligacoes entre as classes
		mon.setControler (cl);
		cont.setControler (cl);
		cont.setStrategist (st);
		
		cl.setStrategist (st);
		cl.setSetup (set);
		//cl.setFCMonitor (mon);  //?
		//cl.setFCContext (cont); //?
		
		st.setControler (cl);
		st.setImplementor (impl);
		st.setSetup (set);
		st.setFCContext (cont);
		
		
		//retornar as fachadas
		v = new Vector();
		v.addElement (mon);
		v.addElement (cont);
	     	
		return 	v;
			
	}
	
	
	/** Retorna a fachada para as funcoes de contextualizacao
	 *  @param FC_ST_Context	fachada de contextualizacao
	 */
	public static FC_ST_Context getContextFacade () {
		//retorna fachada de contextualizacao
		return cont;
		//return null;
	
	}

		
	/** Retorna a fachada para as funcoes de monitoramento
	 * @param FC_ST_Monitor		fachada de monitoramento
	 */
	public static FC_ST_Monitor getMonitorFacade () {
		return mon;
		//return null;
	
	}
}