/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE
 * Classe:  CConnectionHandler
\******************************************************************************/

package COPSE;

import java.io.*;
import java.util.*;


public class CConnectionHandler
    extends Thread
{
    protected CEventConnector    pConnector;

    protected CEventHandler             pEventHandler;

    protected int                       mConnId;
    protected boolean                   mExit;


    public CConnectionHandler ( CEventConnector connector, CEventHandler handler ) //CServerUserSession userSession,
    {
        super();

        pConnector = connector;
        pEventHandler = handler;

        mConnId = 0;
        mExit = false;
    }


    public void run ()
    {
        System.err.println( "[DEBUG] CConnectionHandler - running..." );

        mExit = false;
        while( !mExit )
        {
            try {
                System.err.println( "[DEBUG] CConnectionHandler - Receiving event..." );
                CEvent event = pConnector.Receive();

                System.err.println( "[DEBUG] CConnectionHandler - Sending event to EventHandler..." );
                pEventHandler.AddEvent( event, this );
            }
            catch( Exception e )
            {
                if( !mExit )
                {
                    System.err.println( "[DEBUG] CConnectionHandler - Error during running" );
                    e.printStackTrace( System.err );
                }
            }
        }
        // ...
    }

    public int                  GetConnectionId()   { return mConnId; }

    public CEventConnector      GetConnector()      { return pConnector; }

    public void Close()
    {
        mExit = true;
        pConnector.Close();
        this.stop();
    }


    public void Send( CEvent event )
        throws IOException
    {
        pConnector.Send( event );
    }

}