/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CGUIToolManager
\******************************************************************************/

package COPSE.CLIENT.GUI;


import  java.awt.*;
import  java.awt.event.*;

import  COPSE.*;
import  COPSE.CLIENT.*;


public class    CGUIToolManager
    implements  WindowListener,
                CClientFileControllerListener
{
    protected   CGUIManager             pGUI;

    protected   CClient                 pClient;

    protected   Panel                   pClientPanel;

    protected   CGUIFileControl         pFileControl;


    public String  GetTitle ()     { return "Tool"; }


    public CGUIToolManager ( CGUIManager gui )
    {
        pGUI = gui;
        pClient = null;
        pClientPanel = CreateClientPanel();
    }


    public      Panel       GetClientPanel()                    { return pClientPanel; }

    public      CGUIManager GetGUIManager()                     { return pGUI; }

//    public      void        SetGUIManager (CGUIManager gui)     { pGUI = gui; }
//    public      Component   GetMouseSensibleComponent()         { return pClientPanel; }



    public void AddMenu ( MenuBar menuBar )
    {
        pFileControl = new CGUIFileControl( this );
        pFileControl.AddMenu( menuBar );

        // Add specific tool menus and controls...


    }




    // FILE CONTROL COMMANDS
    public void Save()
    {
        pClient.Save();
    }

    public void OpenClient( String host, int port, String userName )
        throws Exception
    {
        pGUI.GetMainWindow().setCursor( Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR) );
        try{
            pClient = CreateClient( userName.hashCode(), userName, host, port );
        } catch(Exception e)
        {
            pGUI.GetMainWindow().setCursor( Cursor.getDefaultCursor() );
            throw e;
        }

        pClient.AddFileControllerListener( this );
        pGUI.SetClient( pClient );

        System.err.println( "[DEBUG] CGUIManager - Starting Client..." );
        pClient.start();


        /** /
        System.err.println( "[DEBUG] CGUIManager - Waiting until Client is ready..." );
        pClient.WaitUntilReady();
        System.err.println( "[DEBUG] CGUIManager - Client is ready!" );
        /**/

        ChangeMenuSettings();
    }

    protected CClient   CreateClient( int userId, String userName, String host, int port )
        throws Exception
    {
        return new CClient( userId, userName, host, port );
    }

    public boolean IsClientOpen()
    {   return  (pClient != null) && (pClient.isAlive());  }

    public CClient GetClient()
    {   return pClient; }

    public void CloseClient( boolean exit )
    {
        //? Verify if it is the last tool connected to the server
        /*
        if( pClient.IsUserAlone() )
        {
            pSaveChangesDlg = new ...( exit );
            pSaveChangesDlg.setVisible( true );
            return;
        }
        */
        DlgSaveChangesOnClosing( false, exit );
    }

    public  void DlgSaveChangesOnClosing( boolean save, boolean exit )
    {
        if( IsClientOpen() )
        {
            if( save )
            {
                //pClient.Save();
            }

            pGUI.SetClient( null );
            pClient.Exit();

            try{
                pClient.join();
            }catch (Exception e) {}

            pClient = null;
        }

        ChangeMenuSettings();

        if( exit )
        {
            pGUI.Exit();
            System.exit( 0 );
        }
    }










    public      void        ChangeMenuSettings()
    {
        pFileControl.ChangeMenuSettings();
    }


    protected   Panel       CreateClientPanel()                 { return new Panel(); }

    protected   CClientSessionManager   GetSessionManager()
    {
        if( pClient != null )
            return pClient.GetSessionManager();
        return null;
    }






    public void ProcessException( Exception e )
    {
        System.err.println( "[DEBUG] CGUIToolManager - ProcessException..." );
        e.printStackTrace( System.err );
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        {  pFileControl._FileClose( true ); }
    public void windowIconified(WindowEvent e)      {}
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}


    //* FileController Listener Methods
    public void  FileControllerLoaded()
    {
        pGUI.GetMainWindow().setCursor( Cursor.getDefaultCursor() );
    }
    public void  ElementStateChanged (int elemId, CEvent event)       {}


}


