/*


\***/



import java.io.*;
import java.util.*;

import COPSE.*;
import COPSE.CLIENT.*;


public class ClientTestApp
{
    CClient     pClient;
    boolean     mExit;


    public static void main( String[] args )
    {
        new ClientTestApp().run( args );
    }


    public ClientTestApp()
    {
        mExit = false;
    }


    public void run( String[] args )
    {
        System.out.println( "ClientTestApp 1.0.0" );

        if( args.length < 3 )
        {
            System.out.println( "Parameters: <host> <port> <userid>" );
            System.exit(0);
        }

        System.out.println( "DEBUG: Creating the Client object" );
        try {
            pClient = new CClient( args[0], args[1], (new Integer(args[2])).intValue() );
        }
        catch( IOException e )
        {
            e.printStackTrace( System.out );
            System.exit( 0 );
        }

        System.out.println( "DEBUG: Starting the Client object" );
        pClient.start();


        BufferedReader reader = new BufferedReader( new InputStreamReader( System.in ) );
        StringTokenizer tokenizer;

        while( !mExit )
        {
            try{
                tokenizer = new StringTokenizer( reader.readLine() );
                if( !tokenizer.hasMoreTokens() ) continue;
            } catch ( IOException e )
            {   continue; }


            String command = tokenizer.nextToken();
            if( command.equals( "DEBUG" ) )
            {
                pClient.DEBUG_write( System.out );
            }
            else
            if( command.equals( "EXIT" ) )
            {
                pClient.Exit();
                try{
                    pClient.join(10);
                }
                catch( Exception e) {};
                mExit = true;
            }
        }

    }



}

