/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package COPSE
 * Classe: COPSESessionManager
\******************************************************************************/


package COPSE;

import java.io.*;
import java.util.*;


public class COPSESessionManager
    implements Serializable
{
    protected Vector    pSessions;

    public COPSESessionManager()
    {
        pSessions = new Vector();
    }

    public synchronized COPSESession FindSession( int userId )
    {
        Enumeration e = pSessions.elements();
        while( e.hasMoreElements() )
        {
            COPSESession session = (COPSESession) e.nextElement();
            if( session.GetUserId() == userId )
                return session;
        }
        return null;
    }

/*
    public synchronized COPSESession GetSession( int userId )
    {
        COPSESession session = FindSession( userId );
        if( session == null )
        {
            session = new COPSESession( userId );
            pSessions.addElement( session );
        }
        return session;
    }
*/
    public synchronized void AddSession( COPSESession newSession )
    {
        if( newSession == null ) return;

        COPSESession session = FindSession( newSession.GetUserId() );
        if( session == null )
            pSessions.addElement( newSession );
    }

    public synchronized void RemoveSession( COPSESession session )
    {
        if( session != null )
            pSessions.removeElement( session );
    }

    public int GetTotalSessions()
    {
        return pSessions.size();
    }


    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "COPSESessionManager:" );
        Enumeration e = pSessions.elements();
        while( e.hasMoreElements() )
        {
            COPSESession session = (COPSESession) e.nextElement();
            session.DEBUG_write( pStr );
        }
    }

}
