/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE
 * Classe: CProcessStreamConnector
\******************************************************************************/

package COPSE;

import java.io.*;

public class CProcessStreamConnector
    extends CObjectStreamConnector
{
    Process             pProcess;

    public static CProcessStreamConnector New ( Process process )
        throws IOException
    {
        return New( process, true );
    }

    public static CProcessStreamConnector New ( Process process, boolean InOutOrder )
        throws IOException
    {
        CProcessStreamConnector pConn;

        InputStream  in;
        OutputStream out;

        if( InOutOrder )
        {
            in = process.getInputStream();
            out = process.getOutputStream();
            pConn = new CProcessStreamConnector( process, in, out );
        }
        else
        {
            out = process.getOutputStream();
            in = process.getInputStream();
            pConn = new CProcessStreamConnector( process, out, in );
        }

        return pConn;
    }



    private CProcessStreamConnector( Process process, InputStream in, OutputStream out )
        throws IOException
    {
        super( in, out );
        pProcess = process;
    }

    private CProcessStreamConnector( Process process, OutputStream out, InputStream in )
        throws IOException
    {
        super( out, in );
        pProcess = process;
    }

}

