/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe:  CToolSession
\******************************************************************************/

package COPSE;

import java.io.*;
import java.util.*;



public class CToolSession
    implements Serializable
{
    protected int       mToolId;
    protected Vector    pUserSessions;

    public CToolSession( int toolId )
    {
        mToolId = toolId;
        pUserSessions = new Vector();
    }

    public int GetToolId()      { return mToolId; }


    public CUserSession FindSessionByConnection( int connId )
    {
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CUserSession session = (CUserSession) e.nextElement();
            if( session.GetConnectionId() == connId )
                return session;
        }
        return null;
    }

    public CUserSession FindUserSession( String userName )
    {
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CUserSession session = (CUserSession) e.nextElement();
            if( userName.equals( session.GetUserName() ) )
                return session;
        }
        return null;
    }


    public CUserSession FindUserSession( int userId )
    {
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CUserSession session = (CUserSession) e.nextElement();
            if( session.GetUserId() == userId )
                return session;
        }
        return null;
    }


    public void AddUserSession( CUserSession session )
    {
        // Verify if this user is already in this session
        CUserSession temp = FindUserSession( session.GetUserId() );
        if( temp == null )
        {
            pUserSessions.addElement( session );
            session.SetToolSession( this );
        }
    }

    public void RemoveUserSession ( CUserSession session )
    {
        pUserSessions.removeElement( session );
    }

    public Enumeration GetUserSessions()
    {
        return pUserSessions.elements();
    }

    public int GetTotalSessions()
    {
        return pUserSessions.size();
    }



    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "ToolSession: [id:"+GetToolId()+"]" );
        Enumeration e = pUserSessions.elements();
        while( e.hasMoreElements() )
        {
            CUserSession session = (CUserSession) e.nextElement();
            session.DEBUG_write( pStr );
        }
    }


}
