/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe: CServerCommunicationChatHandler
\******************************************************************************/

package COPSE.SERVER;

import java.io.*;
import java.net.*;
import java.util.*;


import COPSE.*;
import COPSE.CONTROL.*;
import FILE.*;


public class CServerCommunicationChatHandler
    extends  CServerCollaborationHandler
{
    protected Vector            pMessages;

    public CServerCommunicationChatHandler( CServerCollaborationManager manager )
    {
        super( manager );
        pMessages = new Vector();
    }


    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        CUserConnectionHandler userHandler = null;
        if( !(handler instanceof CUserConnectionHandler) )
            return;

        CServerToolSession toolSession = GetToolSession(handler);

        switch( event.GetType() )
        {
            case CEvent.EvCollaboration_Communication_Chat_Message:
                {
                    Integer toUserId = (Integer) event.GetArgumentAt(1);
                    if( toUserId.intValue() == 0 )
                        toolSession.NotifyAll( event );
                    else
                        toolSession.NotifyUser( toUserId.intValue(), event );

                    // Add the message to the chat history...
                    pMessages.addElement( event );
                }
                break;

            default:
                super.ProcessEvent( event, handler );
        }
    }

    /*
    public void Exit()
    {
        // Save pMessages

        super.Exit();
    }

    */
}

