/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CServerManagerEventHandler
\******************************************************************************/

package COPSE.SERVER;

import COPSE.*;


public class CServerManagerEventHandler
    extends CServerEventHandler
{
    //CServerManager              pServer;

    // Default Event Handler (if the event isn't important for manager,
    // it is passed to this handler
    CServerEventHandler         pServerEventHandler;

    public CServerManagerEventHandler( CServerManager server, CServerEventHandler handler )
    {
        super( server );

        pServerEventHandler = handler;
    }

    public CServerEventHandler GetEventHandler()    { return pServerEventHandler; }


    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        System.err.println( "[DEBUG] CServerManagerEventHandler: Event ["+event.GetType()+"]" );

        switch( event.GetType() )
        {
            case CEvent.EvCOPSE_Server_Init:
                return;
                //break;

            case CEvent.EvCOPSE_Server_Exit:
                return;
                //break;
        }

        // Send it to the default EventHandler
        pServerEventHandler.ProcessEvent( event, handler );

    }

}


