/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe:  CServerSessionManager
\******************************************************************************/

package COPSE.SERVER;


import java.util.*;

import COPSE.*;
import COPSE.CLIENT.CClientSessionManager;



public class CServerSessionManager
    extends CSessionManager
{
    protected CServer   pServer;

    protected int       mLastConnId;


    public CServerSessionManager( CServer server )
    {
        super();

        pServer = server;
        mLastConnId = 0;
    }


    public synchronized int GetLastConnectionId()
    {
        return mLastConnId;
    }


    public synchronized int CreateNewConnectionId()
    {
        mLastConnId++;
        return mLastConnId;
    }


    public void NotifyAllExcept( CServerUserSession user, CEvent event )
    {
        Enumeration e = pToolSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerToolSession session = (CServerToolSession) e.nextElement();
            session.NotifyAllExcept( user, event );
        }
    }

    public void NotifyAll( CEvent event )
    {
        Enumeration e = pToolSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerToolSession session = (CServerToolSession) e.nextElement();
            session.NotifyAll( event );
        }
    }

    public synchronized CClientSessionManager CloneAsClientSessionManager()
    {
        CClientSessionManager manager = new CClientSessionManager();

        Enumeration e = pToolSessions.elements();
        while( e.hasMoreElements() )
        {
            CServerToolSession session = (CServerToolSession) e.nextElement();
            manager.AddToolSession( session.CloneAsToolSession() );
        }

        return manager;
    }




    public void CloseUserConnectionHandler( int connectionId )
    {
        CServerUserSession session = (CServerUserSession) FindSessionByConnection( connectionId );
        if( session == null )
            return;

        CUserConnectionHandler handler = (CUserConnectionHandler)session.GetConnectionHandler();
        handler.Close();
    }

    public void CloseAllUserConnectionHandlers()
    {
        // Close all client connection handlers
        Enumeration eTools = pToolSessions.elements();
        while( eTools.hasMoreElements() )
        {
            CToolSession tool = (CToolSession) eTools.nextElement();
            Enumeration eUsers = tool.GetUserSessions();
            while( eUsers.hasMoreElements() )
            {
                CServerUserSession user = (CServerUserSession) eUsers.nextElement();
                user.GetConnectionHandler().Close();
            }
        }
    }


}
