/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CHistory
\******************************************************************************/

package FILE;


import java.io.*;
import java.util.*;


public final class  CHistory
    implements      Serializable
{
    //** Attributes
    protected int       mAuthorId;
    protected String    mAuthor;
    protected Date      mCreationDate;
    protected Date      mLastUpdate;

    // Entries
    protected Vector    pEntries;

    protected CFile     pFile;


    //** Constructor
    public CHistory(CFile file)
    {
        pFile = file;

        mAuthorId = 0;
        mAuthor = "";
        mCreationDate = new Date();
        mLastUpdate = new Date();

        pEntries = new Vector();
    }


    //** Attributes
    public CFile    GetFile()                       { return pFile; }
    public void     SetFile( CFile file )           { pFile = file; }

    public String   GetAuthorName( )                { return mAuthor; }
    public int      GetAuthorId( )                  { return mAuthorId; }
    public void     SetAuthor( int id, String name )
    {
        mAuthorId = id;
        mAuthor = name;
    }

    public Date     GetLastUpdate()                 { return mLastUpdate; }
    public void     SetLastUpdate( Date date )      { mLastUpdate = date; }

    public Date     GetCreationDate()               { return mCreationDate; }
    public void     SetCreationDate( Date date )    { mCreationDate = date; }


    //** Entries
    public void     AddHistoryElement   (CHistoryElement he)
    {
        pEntries.addElement( he );
        mLastUpdate = new Date();

        pFile.AddElement( he );
    }

    public Enumeration  GetHistoryElements()        { return pEntries.elements(); }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CHistory");
        pStr.println( "       AuthorId  :     " + mAuthorId );
        pStr.println( "       AuthorName:     " + mAuthor );
        pStr.println( "       CreationDate:   " + mCreationDate );
        pStr.println( "       LastUpdate:     " + mLastUpdate );
    }

}
