/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE.OBJ
 * Classe:  CObjLabel
\******************************************************************************/

package FILE.OBJ;

import  java.io.*;
import  java.awt.Point;

/*************************************************************************
 *  Class CObjLabel
 *************************************************************************/
public class    CObjLabel
    extends     CObjCardinality
{
    protected       int         mArrow;

    public static final int         ArrowNone           = 0;
    public static final int         ArrowTop            = 1;
    public static final int         ArrowBottom         = 2;
    public static final int         ArrowLeft           = 3;
    public static final int         ArrowRight          = 4;



    public CObjLabel ( String text )
    {
        this( text, new Point(0,0), AlignLeft, ArrowNone );
    }


    public CObjLabel ( String text, Point point, int align, int arrow )
    {
        super( text, point, align );
        SetArrow( arrow );
    }

    // Attributes
    public int      GetArrow ()                 { return mArrow; }
    public void     SetArrow ( int arrow )      { mArrow = arrow; }

}