
import java.awt.*;
import java.io.*;

import FILE.*;
import FILE.OBJ.*;


public class  TestFileObj
{
    public static void main ( String[] args )
        throws IOException
    {
        CreateFile( "course.uml" );
    }

    public static void CreateFile( String fileName )
        throws IOException
    {
        CFile file = new CFile( fileName, "." );

        CObjClass       c1, c2, c3, c4, c5, c6;
        CObjAttribute   attrib;
        CObjMethod      method;


        file.AddElement( c1 = new CObjClass( "Person" ) );
        c1.SetRegion( new Rectangle(190, 180, 100, 80) );
        c1.SetAbstract();

            file.AddElement( attrib = new CObjAttribute( "Name" ) );
            attrib.SetType( "String" );
            c1.AddAttribute( attrib );

            file.AddElement( attrib = new CObjAttribute( "Birthday" ) );
            attrib.SetType( "Date" );
            c1.AddAttribute( attrib );

            file.AddElement( method = new CObjMethod( "Age" ) );
            method.SetType( "Integer" );
            c1.AddMethod( method );



        file.AddElement( c2 = new CObjClass( "Subject" ) );
        c2.SetRegion( new Rectangle(150, 10, 100, 80) );

            file.AddElement( attrib = new CObjAttribute( "Name" ) );
            attrib.SetType( "String" );
            c2.AddAttribute( attrib );

            file.AddElement( attrib = new CObjAttribute( "Credits" ) );
            attrib.SetType( "Integer" );
            c2.AddAttribute( attrib );

            file.AddElement( attrib = new CObjAttribute( "Term" ) );
            attrib.SetType( "Integer" );
            c2.AddAttribute( attrib );


        file.AddElement( c3 = new CObjClass( "Professor" ) );
        c3.SetRegion( new Rectangle(310, 10, 100, 60) );

            file.AddElement( attrib = new CObjAttribute( "RegNumber" ) );
            attrib.SetType( "String" );
            c3.AddAttribute( attrib );


        file.AddElement( c4 = new CObjClass( "Student" ) );
        c4.SetRegion( new Rectangle(10, 10, 100, 60) );

            file.AddElement( attrib = new CObjAttribute( "RegNumber" ) );
            attrib.SetType( "String" );
            c4.AddAttribute( attrib );


        file.AddElement( c5 = new CObjClass( "Enrollment" ) );
        c5.SetRegion( new Rectangle(80, 100, 90, 70) );

            file.AddElement( attrib = new CObjAttribute( "Term" ) );
            attrib.SetType( "Integer" );
            c5.AddAttribute( attrib );

            file.AddElement( attrib = new CObjAttribute( "Grade" ) );
            attrib.SetType( "Real" );
            c5.AddAttribute( attrib );



        CObjRelation            rel;
        CObjRelationExtremity   extr;
        CObjCardinality         card;

        file.AddElement( rel = new CObjRelation( CObjRelation.Inheritance ) );
        rel.SetName( "StudentPerson" );
        rel.AddInternalPoint( new Point(50, 220) );

            extr = new CObjRelationExtremity( rel, c1 );    // Person
            extr.SetPoint( CObjRelationExtremity.ExtLeft, 40 );
            extr.SetLabel( new CObjLabel("inherits from") );

            extr = new CObjRelationExtremity( rel, c4 );    // Student
            extr.SetPoint( CObjRelationExtremity.ExtBottom, 40 );


        file.AddElement( rel = new CObjRelation( CObjRelation.Inheritance ) );
        rel.SetName( "ProfessorPerson" );
        rel.AddInternalPoint( new Point(350, 220) );

            extr = new CObjRelationExtremity( rel, c1 );    // Person
            extr.SetPoint( CObjRelationExtremity.ExtRight, 40 );
            extr.SetLabel( new CObjLabel("inherits from") );

            extr = new CObjRelationExtremity( rel, c3 );    // Professor
            extr.SetPoint( CObjRelationExtremity.ExtBottom, 40 );



        file.AddElement( rel = new CObjRelation( CObjRelation.Association ) );
        rel.SetName( "teaches" );

            extr = new CObjRelationExtremity( rel, c3 );    // Professor
            extr.SetPoint( CObjRelationExtremity.ExtLeft, 40 );
            extr.SetCardinality( new CObjCardinality( "1..*" ) );

            extr = new CObjRelationExtremity( rel, c2 );    // Subject
            extr.SetPoint( CObjRelationExtremity.ExtRight, 40 );
            extr.SetCardinality( new CObjCardinality( "*" ) );



        file.AddElement( rel = new CObjRelation( CObjRelation.Association ) );
        rel.SetName( "studies" );

            extr = new CObjRelationExtremity( rel, c4 );    // Student
            extr.SetPoint( CObjRelationExtremity.ExtRight, 40 );
            extr.SetCardinality( new CObjCardinality( "3..8" ) );

            extr = new CObjRelationExtremity( rel, c2 );    // Subject
            extr.SetPoint( CObjRelationExtremity.ExtLeft, 40 );
            extr.SetCardinality( new CObjCardinality( "1..20" ) );


        file.DEBUG_write( System.err );

        file.Save();

    }

}





