/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpHexagon
\******************************************************************************/

package GRAPH;

import java.awt.*;
//import java.io.*;


public class    CGrpHexagon
    extends     CGrpObject
{
    protected   int         mVertOffset;
    protected   CPolyline   pPoly;
    
    
    public CGrpHexagon ( Rectangle rect, int vertical )
    {
        super();
        mVertOffset = vertical;
        SetRegion( rect );
    }

    public void SetVerticalOffset( int vertical )
    {
        if( 3*vertical > pRegion.height )
            mVertOffset = pRegion.height / 4;
        else
            mVertOffset = vertical;
            
        _AdjustPolyline();
    }

    public void SetRegion( Rectangle rect )
    {
        super.SetRegion( rect );
        _AdjustPolyline();
    }

    private void _AdjustPolyline()
    {
        pPoly = new CPolyline();

        pPoly.AddPoint( new Point( pRegion.x, pRegion.y + mVertOffset ) );
        pPoly.AddPoint( new Point( pRegion.x, pRegion.y + pRegion.height - mVertOffset ) );
        pPoly.AddPoint( new Point( pRegion.x + pRegion.width/2, pRegion.y + pRegion.height) );

        pPoly.AddPoint( new Point( pRegion.x + pRegion.width, pRegion.y + pRegion.height - mVertOffset ) );
        pPoly.AddPoint( new Point( pRegion.x + pRegion.width, pRegion.y + mVertOffset ) );
        pPoly.AddPoint( new Point( pRegion.x + pRegion.width/2, pRegion.y ) );

//        pPoly.AddPoint( new Point( pRegion.x, pRegion.y + mVertOffset ) );
    }




    public void           Draw        (CGraphics g)
    {
        Color oldColor;

        if( IsFilled() )
        {
            oldColor = null;
            if( pFillColor != null )
            {
                oldColor = g.getColor();
                g.setColor( pFillColor );
            }
            g.fillPolygon( pPoly );

            if( oldColor != null )
                g.setColor( oldColor );
        }



        oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();
        g.drawPolygon( pPoly );
        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }


    public boolean Contains( int x, int y )
    {   return( pPoly.GetPolygon().contains(x,y) ); }


}