/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpObject
\******************************************************************************/

package GRAPH;

import java.awt.*;
//import java.io.*;


public abstract class CGrpObject
    implements Shape//, Serializable
{
    protected   boolean     mDashed;
    protected   boolean     mFilled;
    protected   Color       pColor;
    protected   Color       pFillColor;
    protected   Rectangle   pRegion;

    public CGrpObject ()
    {
        this( false, false );
    }

    public CGrpObject( boolean dashed )
    {
        this( dashed, false );
    }

    public CGrpObject( boolean dashed, boolean filled )
    {
        mDashed = dashed;
        mFilled = filled;
        pColor = null; // default color...
        pFillColor = null;
        pRegion = null;
    }

    public void SetDashed( boolean dashed )     { mDashed = dashed; }
    public void SetFilled( boolean filled )     { mFilled = filled; }
    public void SetColor ( Color color )        { pColor = color; }
    public void SetFillColor ( Color color )    { pFillColor = color; }
    public void SetRegion( Rectangle rect )     { pRegion = rect; }

    public boolean   IsDashed()                 { return mDashed; }
    public boolean   IsFilled()                 { return mFilled; }
    public Color     GetColor()                 { return pColor; }
    public Color     GetFillColor()             { return pFillColor; }
    public Rectangle GetRegion()                { return pRegion; }

    public boolean   Contains (Point p)
    {
        if( pRegion != null )
            return pRegion.contains(p.x, p.y);
        return false;
    }

    public boolean   Contains (int x, int y)
    {
        return Contains( new Point(x,y) );
    }

    public Rectangle getBounds ()
    {
        if( pRegion != null )
            return pRegion.getBounds();
        return new Rectangle();
    }

    public abstract void           Draw        (CGraphics g);

}