/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpPolyline
\******************************************************************************/

package GRAPH;

//import java.io.*;
import java.awt.*;
//import java.util.*;


public class CGrpPolyline
    extends CGrpObject
{
    protected CPolyline     pPolyline;
//    protected Polygon       pPoly = null;


    public CGrpPolyline( CPolyline poly, boolean dashed )
    {
        super(dashed);
        pPolyline = poly;
    }

    public CGrpPolyline( CPolyline poly )
    {
        this( poly, false );
    }

    public CPolyline GetPolyline()      { return pPolyline; }





    public void Draw( CGraphics g )
    {
        Color oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() )  g.SetDashedPen();

        g.drawPolyline( pPolyline );

        if( IsDashed() )  g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );

    }


    public void     Changed()   { pPolyline.Update(); }


    public boolean Contains( Point pt )
    {
        return pPolyline.Contains( pt );
        /*
        if( pPoly == null )
        {
            Point p = pPolyline.GetFirstPoint();
            pPoly = new Polygon();
            pPoly.addPoint( p.x+5, p.y+5 );
            _AddPoligonPoint( 1 );
            pPoly.addPoint( p.x-5, p.y-5 );
            //p_poly.addPoint( p.x+5, p.y+5 );
        }

        return pPoly.contains(pt.x,pt.y);
        */
    }

/*
    private void _AddPoligonPoint( int pos )
    {
        Point p = pPolyline.GetPointAt(pos);

        if( pos % 2 == 0) // Even
            pPoly.addPoint( p.x+5, p.y-5 );
        else // Odd
            pPoly.addPoint( p.x+5, p.y-5 );

        if( pos < (pPolyline.GetTotalPoints()-1) )
            _AddPoligonPoint( pos+1 );

        if( pos % 2 == 0) // Even
            pPoly.addPoint( p.x-5, p.y-5 );
        else // Odd
            pPoly.addPoint( p.x-5, p.y+5 );

    }
*/

    public Rectangle getBounds()
    {   return pPolyline.GetPolygon().getBounds(); }

}