/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS
 * Classe:  CMetaActivity
\******************************************************************************/

package PROCESS;

import java.io.*;
import java.util.*;

//import FILE.CElement;

import PROCESS.MODEL.*;


public class CMetaActivity
    extends CAbstractActivity
{
    private boolean         mIsAtomic;

    private int             mMetaProcessId; // The MetaProcess that defines this activity

    //private Vector          pCanBeDefinedBy;

    public  CMetaActivity()
    {
        super();

        mIsAtomic = false;
        mMetaProcessId = 0;

        //pCanBeDefinedBy = new Vector();
    }

    // Atomic
    public  boolean IsAtomic()      { return mIsAtomic; }
    public  void    SetAtomicity (boolean isAtomic)     { mIsAtomic = isAtomic; }


    // MetaProcess Definition
    public boolean  IsDefinedByMetaProcess()
    { return mMetaProcessId != 0; }

    public int      GetMetaProcessId()          { return mMetaProcessId; }
    public void     SetMetaProcessId(int id)
    {
        mMetaProcessId = id;
        if( (id != 0) && (pSubActs != null) )
        {
            pSubActs = null;

            CModel model = pProcess;
            model.RemoveElement( pStep.GetSubModel() );
            pStep.SetSubModel( null );
        }
    }



    // SubActivities

    public void         SetSubActivities( CSubModel subModel )
    {
        super.SetSubActivities( subModel );

        /*
        if( pSubActs.size() != 0 )
        {
            // It's not defined as another MetaProcess;
            mMetaProcessId = 0;
        }
        */
    }


}