/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS
 * Classe:  CRole
\******************************************************************************/

package PROCESS;

import java.io.*;
import java.util.*;

//import FILE.CElement;

import PROCESS.MODEL.*;

public class    CRole
    extends     CAbstractRole
{
    protected Vector    pAgentIds;

    public  CRole()
    {
        super();
        pAgentIds   = new Vector();
    }

    // Agents Ids
    public void AddAgentId (int id)
    {
        pAgentIds.addElement(new Integer(id));
    }

    public void RemoveAgentId (int id)
    {
        pAgentIds.removeElement(new Integer(id));
    }

    public Enumeration  GetAgentIds()     { return pAgentIds.elements(); }



    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CRole" );


        if( pAgentIds != null )
        {
            pStr.println( "       --- Agent Ids with this Role ---" );
            pStr.println( "       Ids: " );

            Enumeration en = GetAgentIds();
            while( en.hasMoreElements() )
            {
                Integer i = (Integer) en.nextElement();
                    pStr.print( i + "; " );
            }

            pStr.println( "\n       ---------------------" );
        }


        super.DEBUG_write( pStr );
    }


}


