/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS.MODEL
 * Classe:  CFlow
\******************************************************************************/

package PROCESS.MODEL;

import java.io.*;
import java.util.*;

import FILE.CElement;


public class    CFlow
    extends     CModelElement
{
    protected CConnectionPoint  pPointFrom; // Source Connection Point
    protected CConnectionPoint  pPointTo;   // Target Connection Point

    public      CFlow()
    {
        super();
        pPointFrom = null;
        pPointTo = null;
    }

    // PointFrom
    public CConnectionPoint GetPointFrom()              { return pPointFrom; }
    public void     SetPointFrom (CConnectionPoint cp ) { pPointFrom = cp; }


    // PointTo
    public CConnectionPoint GetPointTo()                { return pPointTo; }
    public void     SetPointTo (CConnectionPoint cp )   { pPointTo = cp; }



    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CFlow (extends CModelElement)" );
        pStr.println( "       FromPoint(Id):   " + pPointFrom.GetId() );
        pStr.println( "       ToPoint(Id):     " + pPointTo.GetId() );

        super.DEBUG_write( pStr );
    }


}
