/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS.MODEL
 * Classe:  CSocket
\******************************************************************************/

package PROCESS.MODEL;


import java.io.*;
import java.util.*;

import java.awt.Point;

public class    CSocket
    extends     CConnectionPoint
{
    protected CStep     pStep;

    protected boolean   mInOut;     // In = true | Out = false
    protected int       mPosition;

    public      CSocket()
    {
        super();
        mInOut = false;
        mPosition = 0;
        pStep = null;
    }

    // Step
    public CStep GetOwnerStep ()                { return pStep; }
    public void  SetOwnerStep ( CStep step )    { pStep = step; }

    // In Out
    public boolean  IsIn()                      { return mInOut; }
    public boolean  IsOut()                     { return !mInOut; }
    public void     SetIn()                     { mInOut = true; }
    public void     SetOut()                    { mInOut = false; }

    // Position
    public void     SetPosition( int pos )      { mPosition = pos; }
    public int      GetPosition()               { return mPosition; }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CSocket (extends CConnectionPoint)" );
        pStr.println( "       StepId:    " + pStep.GetId() );
        pStr.println( "       In(out):   " + mInOut );

        super.DEBUG_write( pStr );
    }



}