/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS.MODEL
 * Classe:  CStep
\******************************************************************************/

package PROCESS.MODEL;

import java.io.*;
import java.util.*;

import java.awt.Rectangle;


public class    CStep
    extends     CModelElement
{
    protected String    mName;
    protected Rectangle mRegion;
    protected CSubModel pSubModel;
    protected Vector    pSockets;


    public  CStep()
    {
        super();

        mName = "";
        mRegion = new Rectangle();
        pSockets = new Vector();
        pSubModel = null;
    }

    // Name
    public void         SetName (String name)       { mName = name; }
    public String       GetName ()                  { return mName; }

    // Region
    public void         SetRegion (Rectangle r)     { mRegion = r; }
    public Rectangle    GetRegion ()                { return mRegion; }

    // SubModel
    public boolean      IsCompound ()               { return pSubModel != null; }
    public CSubModel    GetSubModel ()              { return pSubModel; }
    public void         SetSubModel (CSubModel sm)  { pSubModel = sm; }


    // Socket
    public void AddSocket( CSocket soc )
    {
        pSockets.addElement( soc );
    }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CStep (extends CModelElement)" );
        pStr.println( "       Name:         " + mName );
        pStr.println( "       SubModel:     " + pSubModel );
        pStr.println( "       Num Sockets:  " + pSockets.size() );


        super.DEBUG_write( pStr );
    }



}
