/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PRODUCT
 * Classe:  CProduct
\******************************************************************************/

package PRODUCT;

import java.io.*;
import java.util.*;

import FILE.*;


public class CProduct
    extends  CFile
{
    protected   Vector  pSubProducts;
    protected   Vector  pBaselines;

    private void Reset()
    {
        pSubProducts = new Vector();
        pBaselines  = new Vector();
    }

    public CProduct()
    {
        super();
        Reset();
    }

    public CProduct (String name, String path)
    {
        super (name, path);
        Reset();
    }


    public  Enumeration     GetSubProducts ()       { return pSubProducts.elements(); }
    public  Enumeration     GetBaselines  ()       { return pBaselines.elements(); }


    public void AddSubProduct ( CSubProductEntry subProd )
    {
        AddElement( subProd );
        pSubProducts.addElement(subProd);
    }

    public void RemoveSubProduct ( CSubProductEntry subProd )
    {
        RemoveElement(subProd);
        pSubProducts.removeElement(subProd);
    }


    public CDocEntry    FindDocEntry( int docId )
    {
        CElement elem = GetElement( docId );
        if( elem instanceof CDocEntry )
            return (CDocEntry) elem;
        return null;
    }

/* * /
    public CDocument    GetDocument( int docId )
    {
        CDocEntry entry = FindDocEntry( docId );
        if( entry == null )
            return null;






/* */

    public void AddBaseline ( CBaseline base )
    {
        AddElement( base );
        pBaselines.addElement(base);
    }

    public void RemoveBaseline ( CBaseline base )
    {
        RemoveElement( base );
        pBaselines.removeElement(base);
    }



}