/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  COPEDlgActivity
 ******************************************************************************/

package TOOL.PROCESS.CLIENT;


import java.awt.*;
import java.awt.event.*;
import java.util.*;

import COPSE.CLIENT.GUI.*;
import PROCESS2.*;


/*************************************************************************
 *  Class COPEDlgActivity
 *************************************************************************/
public class COPEDlgActivity extends Dialog
    implements WindowListener, ActionListener, ItemListener, TextListener
{
    protected CGUIManager           pGUI;
    protected COPEActivityControl   pControl;


    protected CActivity             pOldActivity = null;
    protected CActivity             pNewActivity = null;
    protected boolean               mChanged = false;

/*
    protected UMLDlgFeature         pDlgFeature = null;
    protected boolean               mFeatureEdit = false;
    protected boolean               mFeatureNew = false;
*/

	TextField textName;

	TextArea textDescription;

	Choice choiceState;

	CheckboxGroup groupType;
	Checkbox radioManual;
	Checkbox radioAuto;
	Choice choiceTools;

	List listInputs;
	List listOutputs;
	List listRoles;

	Button btnOk;
	Button btnCancel;


	public COPEDlgActivity( CGUIManager gui, boolean modal, COPEActivityControl control)
	{
	    super(gui.GetMainWindow(), modal);
	    pGUI = gui;
	    pControl = control;

	    pOldActivity = (CActivity) pControl.GetSelectedElement();
	    //try{
    	    pNewActivity = pOldActivity.CloneOnlyInfo();
    	//} catch( CloneNotSupportedException e ) {}
        mChanged = false;

        addWindowListener( this );


		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();
		setSize(insets.left + insets.right + 534,insets.top + insets.bottom + 342);
		setFont(new Font("Helvetica", Font.PLAIN, 12));

		Label label;

		label = new Label("Activity:");
		label.setBounds(insets.left + 21,insets.top + 15,56,15);
		add(label);

		textName = new TextField();
		textName.setBounds(insets.left + 84,insets.top + 11,175,23);
        textName.addTextListener( this );
		add(textName);



		label = new Label("Description:");
		label.setBounds(insets.left + 21,insets.top + 49,70,15);
		add(label);

		textDescription = new TextArea();
		textDescription.setBounds(insets.left + 21,insets.top + 64,238,87);
		add(textDescription);


		label = new Label("State:");
		label.setBounds(insets.left + 291,insets.top + 49,56,15);
		add(label);

		choiceState = new Choice();
		choiceState.addItem("Initiated");
		choiceState.addItem("Running");
		choiceState.addItem("Active");
		choiceState.addItem("Complete");
		choiceState.addItem("Suspended");
		choiceState.addItem("Terminated");
		choiceState.setBounds(insets.left + 347,insets.top + 20,175,83); // top+49
		choiceState.addItemListener( this );
		add(choiceState);

		label = new Label("Type");
		label.setBounds(insets.left + 291,insets.top + 79,56,15);
		add(label);

		groupType = new CheckboxGroup();

		radioManual = new Checkbox("Manual (extern)", groupType, false);
		radioManual.setBounds(insets.left + 291,insets.top + 101,119,19);
		radioManual.addItemListener( this );
		add(radioManual);

		radioAuto = new Checkbox("Automated", groupType, false);
		radioAuto.setBounds(insets.left + 291,insets.top + 128,80,18);
		radioAuto.addItemListener( this );
		add(radioAuto);

		choiceTools = new Choice();
		choiceTools.addItem("<not listed>");
		choiceTools.addItem("Class Diagram Edition");
		choiceTools.addItem("Revision Meeting");
		choiceTools.setBounds(insets.left + 378,insets.top + 100,144,75);
		choiceTools.addItemListener( this );
		add(choiceTools);




		label = new Label("Inputs from:");
		label.setBounds(insets.left + 21,insets.top + 169,70,15);
		label.setForeground(Color.darkGray);
		add(label);

		listInputs = new List(0,false);
		listInputs.setBounds(insets.left + 21,insets.top + 184,112,139);
//		listInputs.setBackground(new Color(12632256));
		listInputs.setEnabled(false);
		add(listInputs);

		label = new Label("Outputs to:");
		label.setBounds(insets.left + 147,insets.top + 169,70,15);
		label.setForeground(Color.darkGray);
		add(label);

		listOutputs = new List(0,false);
		listOutputs.setBounds(insets.left + 147,insets.top + 184,112,139);
//		listOutputs.setBackground(new Color(12632256));
		listOutputs.setEnabled(false);
		add(listOutputs);



		label = new Label("Roles:");
		label.setBounds(insets.left + 291,insets.top + 169,70,15);
		label.setForeground( Color.darkGray );
		add(label);

		listRoles = new List(0,false);
		listRoles.setBounds(insets.left + 291,insets.top + 188,228,90);
//		listRoles.setBackground(new Color(12632256));
		listRoles.setEnabled(false);
		add(listRoles);


		btnOk = new Button("Ok");
		btnOk.setBounds(insets.left + 336,insets.top + 296,88,27);
		btnOk.addActionListener( this );
		add(btnOk);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 431,insets.top + 296,87,26);
		btnCancel.addActionListener( this );
		add(btnCancel);


		setTitle("Activity Info Edit");
		setResizable( false );
		//}}
	}



    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);

            DataToView();
        }

    	super.setVisible( visible );
    }



    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOk )
            _Close( true );
    }

    // ItemListener
    public void itemStateChanged( ItemEvent e )
    {
        Object source = e.getSource();

        if( source == radioManual )
        //if( radioManual.getState() )
        {
            choiceTools.select( 0 );
            choiceTools.setEnabled( false );
        }
        else
        if( source == radioAuto )
        {
            choiceTools.setEnabled( true );
            choiceTools.select( 1 );
        }
        else
        if( source == choiceState )
        {
            int oldState = pNewActivity.GetState();
            int newState = choiceState.getSelectedIndex();

            if( (newState != oldState) && !CActivityState.AS_Transitions[oldState][newState] )
                choiceState.select( oldState ); //setSelectedIndex( oldState );
        }

    }

    // TextListener
    public void textValueChanged( TextEvent event )
    {
        if( event.getSource() == textName )
        {
            boolean empty = textName.getText().equals("");
            if( btnOk.isEnabled() == empty )
                btnOk.setEnabled( !empty );
        }
    }


    public boolean      HasChanged()    { return mChanged; }

    public CActivity    GetNewActivity()   { return pNewActivity; }

    public void DataToView()
    {
        textName.setText( pNewActivity.GetName() );
	    textDescription.setText( pNewActivity.GetDescription() );
	    choiceState.select( pNewActivity.GetState() );

	    if( pNewActivity.GetToolId() == 0 )
	    {
	        radioManual.setState( true );
            choiceTools.select( 0 );
	        choiceTools.setEnabled( false );
	    }
	    else
	    {
	        radioAuto.setState( true );
            choiceTools.select( pNewActivity.GetToolId() );
	        choiceTools.setEnabled( true );
	    }

        _UpdateListFlows();
        _UpdateListRoles();
    }


    private void _UpdateListFlows()
    {
        Enumeration e;

        listInputs.removeAll();
        listOutputs.removeAll();

        e = pOldActivity.GetFromActivities();
        while( e.hasMoreElements() )
        {
            CActivity act = (CActivity) e.nextElement();
            listInputs.addItem( act.GetName() );
        }

        e = pOldActivity.GetToActivities();
        while( e.hasMoreElements() )
        {
            CActivity act = (CActivity) e.nextElement();
            listOutputs.addItem( act.GetName() );
        }
    }

    private void _UpdateListRoles()
    {
        Enumeration e;

        listRoles.removeAll();

        e = pOldActivity.GetRoles();
        while( e.hasMoreElements() )
        {
            CAbstractRole role = (CAbstractRole) e.nextElement();
            listRoles.addItem( role.GetName() );
        }
    }




    public void ViewToData()
    {
        String text;

        text = textName.getText();
        if( !text.equals( pNewActivity.GetName() ) )
        {   pNewActivity.SetName( text );  mChanged = true; }

        text = textDescription.getText();
        if( !text.equals( pNewActivity.GetDescription() ) )
        {   pNewActivity.SetDescription( text );  mChanged = true; }

        if( pNewActivity.SetState( choiceState.getSelectedIndex() ) )
            mChanged = true;

        boolean bool = radioManual.getState();
        if( bool != (pNewActivity.GetToolId() == 0) )
        {
            if( bool )
                pNewActivity.SetToolId( 0 );
            else
                pNewActivity.SetToolId( choiceTools.getSelectedIndex() );
        }
    }

    protected void _Close( boolean ok )
    {
        // For while...
        if( ok )
            ViewToData();

        pControl.CloseDlgEdit(ok);
    }

}
