/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  ProcessGUIToolManager
\******************************************************************************/

package TOOL.PROCESS.CLIENT;

import  java.awt.*;
import  java.util.*;


import  COPSE.CEvent;
import  COPSE.CLIENT.*;
import  COPSE.CLIENT.GUI.*;
import  COPSE.CONTROL.*;

//import  GRAPH.*;

import  FILE.CElement;
import  PROCESS2.*;

//import  TOOL.PROCESS.*;



public class    ProcessGUIToolManager
    extends     CGUIToolManager
    //implements  WindowListener, CClientFileControllerListener
{
/*
    protected   ProcessClassControl     pClassControl;
    protected   ProcessRelationControl  pRelationControl;

    protected   CUMLGraphElement        pSelectedElement;
*/

    protected   COPEActivityControl     pActivityControl;

    protected   CElement                pSelectedElement;

    protected   ProcessControlPanel     pProcessControlPanel;


    public String  GetTitle ()
    {   return "COPE - Cooperative Process Editor";  }

    public ProcessGUIToolManager ( CGUIManager gui )
    {
        super( gui );
    }

    protected CClient   CreateClient( int userId, String userName, String host, int port )
        throws Exception
    {
        return new ProcessClient( userId, userName, host, port );
    }


    public void AddMenu ( MenuBar menuBar )
    {
        super.AddMenu( menuBar );

        // Add specific tool menus and controls...
        pActivityControl = new COPEActivityControl( this );
        pActivityControl.AddMenu( menuBar );


/*
        pClassControl = new ProcessClassControl(this);
        pClassControl.AddMenu( menuBar );

        pRelationControl = new ProcessRelationControl(this);
        pRelationControl.AddMenu( menuBar );
*/
}



    public      void        ChangeMenuSettings()
    {
        super.ChangeMenuSettings();

        pActivityControl.ChangeMenuSettings();
        //pClassControl.ChangeMenuSettings();
        //pRelationControl.ChangeMenuSettings();
    }

/* */
    public      void        SetSelectedElement( CElement element )
    {
        if( pSelectedElement!=null )
        {
            if( pSelectedElement instanceof CAbstractActivity )
                pActivityControl.SetSelectedElement( null );

/* * /
            else
            if( pSelectedElement instanceof CFlow )
                pFlowControl.SetSelectedElement( null );
            else
            if( pSelectedElement instanceof CAbstractRole )
                pRoleControl.SetSelectedElement( null );
            else
            if( pSelectedElement instanceof CDocument ) // CDocumentType ???
                pDocControl.SetSelectedElement( null );
/* */
        }

        pSelectedElement = element;

        if( pSelectedElement != null )
        {
            if( pSelectedElement instanceof CAbstractActivity )
                pActivityControl.SetSelectedElement( (CAbstractActivity)pSelectedElement );
/* * /
            else
            if( pSelectedElement instanceof CFlow )
                pFlowControl.SetSelectedElement( (CFlow)pSelectedElement );
            else
            if( pSelectedElement instanceof CAbstractRole )
                pRoleControl.SetSelectedElement( (CAbstractRole)pSelectedElement );
            else
            if( pSelectedElement instanceof CDocument ) // CDocumentType ???
                pDocControl.SetSelectedElement( (CDocument)pSelectedElement );
/* */
        }

    }



    protected   Panel       CreateClientPanel()
    {
        pProcessControlPanel = new ProcessControlPanel(this);
        return pProcessControlPanel;
    }


    public void CloseClient( boolean exit )
    {
        pActivityControl.SetEnabled(false);
        //pClassControl.SetEnabled( false );
        //pRelationControl.SetEnabled( false );

        pProcessControlPanel.SetFileController( null );

        super.CloseClient( exit );

        if( pClient == null )
        {
        }
    }





/*
    public void CreateNewClass( Rectangle rect )
    {
        ProcessDlgClassNew dlg = new ProcessDlgClassNew( this, rect );
        dlg.setVisible( true );
    }

    public void CreateNewRelation( CPolyline poly, CObjClass classes[] )
    {
        int classesId[] = new int[2];
        CSidePosition sides[] = new CSidePosition[2];
        Point first, last, aux;

        first = poly.GetFirstPoint();
        last = poly.GetLastPoint();

        poly.RemovePoint( first );
        poly.RemovePoint( last );


        classesId[0] = classes[0].GetId();
        {   try {
                aux = poly.GetFirstPoint();
            } catch (Exception e) { aux = last; }
        }
        sides[0] = CSidePosition.CreateSidePosition( classes[0].GetRegion(), first, aux );


        classesId[1] = classes[1].GetId();
        {   try {
                aux = poly.GetLastPoint();
            } catch (Exception e) { aux = first; }
        }
        sides[1] = CSidePosition.CreateSidePosition( classes[1].GetRegion(), last, aux );


        ProcessDlgRelationNew dlg = new ProcessDlgRelationNew( this, poly, classesId, sides );
        dlg.setVisible( true );
    }

*/

    //* FileController Listener Methods
    public void  FileControllerLoaded()
    {
        super.FileControllerLoaded();

        System.err.println( "{DEBUG} ProcessGUIToolManager - FileController Loaded..." );
        pProcessControlPanel.SetFileController( pClient.GetFileController() );

        pActivityControl.Activate();
//        pClassControl.Activate();
//        pRelationControl.Activate();
    }


    public void  ElementStateChanged (int elemId, CEvent event)
    {
        int type = event.GetType();

        //pClientPanel.repaint(); // ?
        switch( type )
        {
            case CEvent.EvCOPSE_FileController_Element_New:
                { /*
                    pProcessCanvas.AddElement( elemId );
                    int connId = ((Integer) event.GetArgumentAt(0) ).intValue();
                    if( pClient.GetSessionManager().GetClientSession().GetConnectionId() == connId )
                        pProcessCanvas.SelectElement( elemId );
                   */
                }
                break;

            case CEvent.EvCOPSE_FileController_Element_Delete:
                //pProcessCanvas.RemoveElement( elemId );
                break;


            case CEvent.EvCOPSE_FileController_Element_Lock:
                {
                    if( (pSelectedElement != null) &&
                        (pSelectedElement.GetId() == elemId) )
                    {

                        if( (pActivityControl.GetSelectedElement() == pSelectedElement) && pActivityControl.IsWaitingForLock() )
                        {
                            pActivityControl.ReceiveLockConfirmation();
                        }

                        /*
                        else
                        if( (pRelationControl.GetSelectedElement() == pSelectedElement) && pRelationControl.IsWaitingForLock() )
                        {
                            pRelationControl.ReceiveLockConfirmation();
                        }
                        */
                    }

                    pProcessControlPanel.UpdateElement( elemId );
                }
                break;

            // TEMP - DEBUG
            case CEvent.EvCOPSE_FileController_Element_Update:
                {
                    /*
                    CElement elem = pClient.GetFileController().GetFile().GetElement( elemId );
                    if( elem instanceof CObjRelation )
                    {
                        System.err.println( "[DEBUG] ProcessGUIToolManager - Received Event Update Relation: ");
                        elem.DEBUG_write( System.err );
                    }
                    */
                }
                //break;

            default:
                pProcessControlPanel.UpdateElement( elemId );
        }

        pProcessControlPanel.repaint();

/*  */
    }


}


