/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerSessionManager
\******************************************************************************/



import java.io.*;
import java.util.*;

import COPSE.*;
//import COPSE.SERVER.*;

public class COPSEServerSessionManager
    extends COPSESessionManager
{
    public COPSEServerSessionManager()
    {
        super();
    }

    public synchronized void NotifyAll( CEvent event )
    {
        Enumeration e = pSessions.elements();
        while( e.hasMoreElements() )
        {
            COPSEServerSession session = (COPSEServerSession) e.nextElement();
            session.Notify( event );
        }
    }

    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "COPSEServerSessionManager:" );
        super.DEBUG_write(pStr);
    }

    public COPSESessionManager CloneAsCOPSESessionManager()
    {
        COPSESessionManager sMgr = new COPSESessionManager();

        Enumeration e = pSessions.elements();
        while( e.hasMoreElements() )
        {
            COPSEServerSession session = (COPSEServerSession) e.nextElement();
            sMgr.AddSession( session.CloneAsCOPSESession() );
        }

        return sMgr;
    }

    public void CloseAllConnectionHandlers()
    {
        Enumeration e = pSessions.elements();
        while( e.hasMoreElements() )
        {
            COPSEServerSession session = (COPSEServerSession) e.nextElement();
            session.GetConnectionHandler().Close();
        }
    }

}
