/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProjectsIndex
\******************************************************************************/


import java.io.*;
import java.util.*;


public class ProjectsIndex
    implements Serializable
{
    int         mLastId;
    Vector      pProjects;

    public ProjectsIndex ()
    {
        mLastId = 0;
        pProjects = new Vector();
    }


    public Enumeration GetProjects()
    {   return pProjects.elements(); }

    public ProjectEntry NewProject()
    {
        mLastId++;
        ProjectEntry prj = new ProjectEntry( mLastId );
        pProjects.addElement( prj );
        return prj;
    }

    public void RemoveProject( ProjectEntry prj )
    {
        pProjects.removeElement( prj );
    }

    public void DEBUG_write( PrintStream out )
    {
        out.println( "** Projects Index **\n" );
        out.println( "LastId:     " + mLastId );
        out.println( "Projects:   " + pProjects.size() );

        Enumeration e = pProjects.elements();
        while( e.hasMoreElements() )
        {
            ProjectEntry prj = (ProjectEntry) e.nextElement();
            prj.DEBUG_write( out );
        }

        out.println( "*********************" );
    }
}

