/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: UserManager
\******************************************************************************/


import java.io.*;
import java.util.*;

public class Teste
{

    public static void main( String[] args )
    {
        new Teste().run( args );
    }


    public Teste()
    {}


    public void run( String[] args )
    {
        try {
            System.out.println( "Creating Index...");
            CreateProjectsIndex();

            System.out.println( "Loading Index...");
            LoadProjectsIndex();
        }
        catch( Exception e ) {};

    }

    protected void CreateProjectsIndex()
        throws Exception
    {
        //
        ProjectsIndex pIndex;
        ProjectEntry prj;

        pIndex = new ProjectsIndex();

        prj = pIndex.NewProject();
        prj.SetName( "copse" );
        prj.SetDescription( "COPSE Development Project" );
        prj.SetPath( "../prj/copse" );

        prj = pIndex.NewProject();
        prj.SetName( "cute" );
        prj.SetDescription( "CUTE Development Project" );
        prj.SetPath( "../prj/cute" );


        FileOutputStream file = new FileOutputStream( "projects.index" );
        ObjectOutputStream output = new ObjectOutputStream( file );

        output.writeObject( pIndex );

        file.close();
    }


    protected void LoadProjectsIndex()
        throws Exception
    {
        ProjectsIndex pIndex;

        FileInputStream file = new FileInputStream( "projects.index" );
        ObjectInputStream input = new ObjectInputStream( file );

        pIndex = (ProjectsIndex) input.readObject();

        file.close();

        pIndex.DEBUG_write( System.out );
    }

}