/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerProjectManager
\******************************************************************************/


import java.io.*;
import java.util.*;


//import COPSE.*;
import FILE.*;
import PROCESS.*;

//import AGENT.*;
//import PROCESS.MODEL.*;
//import PRODUCT.*;


public class COPSEServerProjectManager
{
    //protected   COPSEServer             pCOPSEServer;

    protected   CProjectEntry           pProjectEntry;


    // Common File Servers
    protected   Vector                  pServerManagers;


    // Special Project Files Managers (Servers)
    protected   CProductManager         pProductManager;
    protected   CUsersManager           pUsersManager;

//    protected   CProcessManager         pProcessManager;

/*
    protected   CToolsManager           pToolsManager;

    // ...
*/

    protected   int         mLastUsedServerSocketPort;


    public COPSEServerProjectManager( /*COPSEServer server,*/ String projectId, String host, int port )
        throws Exception
    {
        //pCOPSEServer = server;

        System.err.println( "[DEBUG] COPSEServerProjectManager - Open project..." );
        mLastUsedServerSocketPort = port+1;
        pProjectEntry = _OpenProject( projectId, host, port );



        pServerManagers = new Vector();

        System.err.println( "[DEBUG] COPSEServerProjectManager - Create ProductManager..." );
        pProductManager = new CProductManager( this );

        System.err.println( "[DEBUG] COPSEServerProjectManager - Create UsersManager..." );
        pUsersManager   = new CUsersManager( this );


//        System.err.println( "[DEBUG] COPSEServerProjectManager - Create ProcessManager..." );
//        pProcessManager = CProcessManager.New( this );

        /*
        pToolsManager   = new CToolsManager( this );

        //...
        */

        System.err.println( "[DEBUG] COPSEServerProjectManager - ProjectManager is ready..." );
    }


    protected   int         GetNextServerSocketPort()
    {
        mLastUsedServerSocketPort++;
        return mLastUsedServerSocketPort;
    }

    public String           GetProjectDir()         { return pProjectEntry.GetPath(); }

    public CProductManager  GetProductManager()     { return pProductManager; }
    public CUsersManager    GetUsersManager()       { return pUsersManager; }
//    public CProcessManager  GetProcessManager()     { return pProcessManager; }



/*  // ProductManager
    public String GetProductDir()
    {
        return new String( pProjectEntry.GetPath() + "/product" );
    }
*/

/*  // ProductManager ??
    public String GetServerNameFor( CLocator locator )
    {
        if( locator.GetDocId() == 0 )
        {
            // Special Files
            switch( locator.GetVerId() )
            {
                case 0: // Process
                    return "ProcessServer";
            //    case 1:
            }
        }
        else
            return "DefaultFileServer";
    }
*/




/*

    private void _LoadProduct()
    {
        try{
            pProduct = (CProduct) CFile.Load( "product.copse", GetProjectDir() );
        } catch (Exception e)
        {
            pProduct = _CreateDefaultProduct();
        }
    }


    private CFile _LoadSpecialProjectFile( int type )
    {
        CFile file;

        switch( type )
        {
            case 0:     // Process
                {
                    CProcess process;
                    try {
                        process = (CProcess) CFile.Load( "process.copse", GetProjectDir() );
                    } catch( Exception e )
                    {
                        process = _CreateDefaultProcess();
                    }
                    return process;
                }


            case 1:     // Users
                try{
                    file = CFile.Load( "users.copse", GetProjectDir() );
                } catch(Exception e)
                {
                    file = _CreateDefaultUsers();
                }
                return file;


            case 2:    // Product
                return pProduct;


            case 3:
                ;

            default:
                file = new CFile();

        }
        return file;
    }



    public CFile LoadFile( CLocator locator )
        throws IOException
    {
        // Special Project "Files"
        if( locator.GetDocId() == 0 )
            return _LoadSpecialProjectFile( locator.GetVersionId() );


        CElement elem = pProduct.GetElement( locator.GetDocId() );
        if( !(elem instanceof CDocEntry) )
            throw new IOException( "Invalid Document reference in Product definition!" );

        CDocEntry entry = (CDocEntry) elem;



        // Load Document
        CDocument doc;
        try {
            doc = entry.Load( GetProductDir() );
        } catch ( Exception e1 )
        {
            // Create the Document
            doc = entry.Create( GetProductDir() );

            new CDocument( entry.GetPath(), GetProductDir() );
            doc.SetTypeId( entry.GetDocTypeId() );
        }

        // Get Version
        CVersion version = doc.GetVersion( locator.GetVersionId() );
        if( version == null )
        {   // Create a new Version
            version = doc.CreateVersion();
            try { doc.Save(); } catch (IOException e){};
            locator.SetVersionId( version.GetId() );
        }

        // Load File
        CFile file = version.GetFile( GetProductDir() );
        if( file == null )
        {
            switch( doc.GetTypeId() )
            {
                case 0:
                default:
                    // Create the file of this version
                    file = new CFile( version.GetFileName(),
                        GetProductDir() + "/" + entry.GetParentPath() );
                    //???
                    break;
            }
        }

        file.Save();
        return file;
    }




    private CProcess _CreateDefaultProcess()
    {
        CProcess process = new CProcess( "process.copse", GetProjectDir() );

        CModelHeader header;
        process.AddElement( header = new CModelHeader() );
        process.SetModelHeader( header );
        header.SetName( "Process" );

        CSubModel   submodel;
        process.AddElement( submodel = new CSubModel() );

        header.SetSubModel( submodel );

        process.SetupActivities();

        try {
            process.Save();
        } catch (IOException e) {};
        return process;
    }


    private CFile _CreateDefaultUsers()
    {
        CFile file = new CFile( "users.copse", GetProjectDir() );

        CMember member = new CMember();
        member.SetLogin("admin");
        member.SetPassword("admin");
        member.SetName("Project Administrator");

        file.AddElement( member );

        try {
            file.Save();
        } catch (IOException e) {};
        return file;
    }


    private CProduct _CreateDefaultProduct()
    {
        CProduct prod = new CProduct( "product.copse", GetProjectDir() );

        try {
            prod.Save();
            File file = new File( GetProductDir() );
            file.mkdirs();
        } catch (IOException e) {};
        return prod;
    }


/*
    private void _LoadUsers()
        throws Exception
    {
        // Load Users...
        try {
            pPrjUsers = CFile.Load( "users.copse", pProjectEntry.GetPath() );
        } catch (Exception e)
        {
            // TEMPORARY ???
            pPrjUsers = new CFile( "users.copse", pProjectEntry.GetPath() );
            CMember member = new CMember();
            member.SetLogin("admin");
            member.SetPassword("admin");
            member.SetName("Project Administrator");

            pPrjUsers.AddElement( member );
            pPrjUsers.Save();
        }

    }


    private void _LoadProcess()
        throws Exception
    {
        // Load Process ...
        try {
            // Try to Load existing process
            pPrjProcess = (CProcess) CFile.Load( "process.copse", pProjectEntry.GetPath() );
        } catch (Exception e)
        {
            // TEMPORARY ???
            // If something wrong happens, it tries to create another process
            CProcess process = new CProcess( "process.copse", pProjectEntry.GetPath() );

            CModelHeader header;
            process.AddElement( header = new CModelHeader() );
            process.SetModelHeader( header );
            header.SetName( "Process" );

            CSubModel   submodel;
            process.AddElement( submodel = new CSubModel() );

            header.SetSubModel( submodel );

            process.SetupActivities();
            process.Save();
        }
    }
*/

/*
    public CFile        GetProjectUsers()       { return pPrjUsers; }
    public CProcess     GetProjectProcess()     { return pPrjProcess; }
*/












    private CProjectEntry _OpenProject( String projectId, String host, int port )
        throws Exception
    {
        CProjectsIndex pIndex;
        CProjectEntry prj;

        // Read Projects Index...
        pIndex = CProjectsIndex.LoadFrom( "projects.index" );

        prj = pIndex.FindProject( projectId );

        if( prj == null )
            throw new Exception( "Project '"+projectId+"' not found!" );

        if( prj.IsOpen() )
            throw new Exception( "Project '"+projectId+"' is open!" );

        // Change the Project Status...
        prj.Open( host, port );

        // Save this information to ProjectsIndex
        pIndex.SaveTo( "projects.index" );

        return prj;
    }




    private void _CloseProject()
    {
        if( pProjectEntry == null )
            return;

        CProjectsIndex pIndex;
        CProjectEntry prj;

        try {
            // Read Projects Index...
            pIndex = CProjectsIndex.LoadFrom( "projects.index" );

            prj = pIndex.FindProject( pProjectEntry.GetId() );

            // Change the Project Status...
            prj.Close();

            // Save this information to ProjectsIndex
            pIndex.SaveTo( "projects.index" );

        } catch( Exception e ) {}

        pProjectEntry = null;
    }




    public void Close()
    {
        System.err.println( "[DEBUG] COPSEServerProjectManager - ProjectManager Close:" );
        // if any of documents has changed, then save it
/*
        try {
                pProductManager.Exit();
                ...
        } catch(IOException e) {}
*/

//        System.err.println( "[DEBUG] COPSEServerProjectManager - Closing ProcessManager..." );
//        pProcessManager.Close();

        System.err.println( "[DEBUG] COPSEServerProjectManager - Closing UsersManager..." );
        pUsersManager.Close();

        System.err.println( "[DEBUG] COPSEServerProjectManager - Closing ProductManager..." );
        pProductManager.Close();


        System.err.println( "[DEBUG] COPSEServerProjectManager - Closing Project..." );
        _CloseProject();

        System.err.println( "[DEBUG] COPSEServerProjectManager - ProjectManager closed!" );
    }

}